
	/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
	//                                             	   
    // Trade, Quality Upgrading and Input Linkages: A Theory with Evidence from Colombia (Cecilia Fieler, Marcela Eslava, Daniel Xu), August 2017*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
	//                                             	   
    // Construction of plant level price indices

	// Input files:  
	//  "Materia.dta" database for each year(products raw databases)
	//  "Producto.dta" database for each year(products raw databases)

	*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

    *>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  Program's Parameters <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	pause on
    	set more off, perm
	clear
	clear matrix
	set mem 50m
	
	*======================================================
	*=MODIFY THE FOLLOWING PARAMETERS TO APPROPRIATE ROUTE=
	*========================================================
	
	global cd "Y:\TC1_MARCELA ESLAVA\FEX_AER_programs\prices"
	/*global $cd: change only "TC1_MARCELA ESLAVA" to your user. When you unzip the program folder to your user, the route must have been created*/ 

	cd "\\bdatos_server\SALA DE PROCESAMIENTO\TC1_MARCELA ESLAVA\Primary Databases\Eam\Productos y materiales"
	/*change preceding line to route where the original plant-product level databases provided by DANE are stored, both for materials and products. DANE should have provided separate by-year files called "Materias" and "Productos". Each file must be saved into a folder called "yXXXX" where XXXX is the corresponding year. For instance, the file "materiales" for 1993 must be saved into the folder y1993. */

	global other "Y:\TC1_MARCELA ESLAVA\FEX_AER_programs\external databases"
	/*global $other: change only "TC1_MARCELA ESLAVA" to your user. When you unzip the program folder to your user, the route must have been created and the public access databases saved to that route*/

	
	cap mkdir "$cd\temp_database"
	cap mkdir "$cd\logs"

	*======================================================
	*=FOLLOWING LINES EXECUTE CODE THAT CREATES PLANT-LEVEL INDEX=
	*========================================================


	*=================================================================
	* Programs 1. and 2.: create input price index
	*===============================================================	
	do "$cd\0.1.price index inputs preparing.do"
	do "$cd\0.2.price index inputs.do"


	*=================================================================
	* Programs 3. and 4.: create input price index
	*===============================================================	
	do "$cd\0.3.price index outputs preparing.do"
	do "$cd\0.4.price index outputs.do"

