	cap log close
	log using "$logfile_dir\Create 1994 from Raw(`c(current_date)').log", replace

*	____________________________________________________________________________

*		 						 **** 1994 **** 
*	____________________________________________________________________________

	
*	______________

*	i. Reshape 
*	______________
	
	
	clear

	clear
	use "${pym}\y1994\cap7i.dta", clear
	drop mar94
	gen cero="_"
	egen cap_reng=concat(cero capitulo cero renglon)
	destring cap_reng, replace
	reshape wide   valci71 valci72 valci73 valci74 capitulo renglon fecha ///
	cero, i( nordest ) j( cap_reng ) string
	drop cero* renglon* capitulo* fecha*
	save "${cd}\db\intermediate\cap7i_r.dta", replace
	 
	clear
	use "${pym}\y1994\cap8i.dta", clear
	drop mar94
	gen cero="_"
	egen cap_reng=concat(cero capitulo cero renglon)
	destring cap_reng, replace
	reshape wide   valci81 valci82 valci83 valci84 valci85 valci86 valci87 valci88 fecha ///
	capitulo renglon cero, i( nordest ) j( cap_reng ) string
	drop cero* renglon* capitulo* fecha*
	save "${cd}\db\intermediate\cap8i_r.dta", replace

	clear
	use "${pym}\y1994\nuevas94.dta", clear
	drop fecha mar94
	save "${cd}\db\intermediate\nuevas94_r.dta", replace

	clear
	use "${pym}\y1994\control.dta", clear 
	keep if cuadro==1
	save "${cd}\db\intermediate\control94.dta", replace
	
	clear
	use "${pym}\y1994\materia.dta", clear
	drop if codigo==999
	collapse (sum) valorcom  valqcons, by(nordest)
	save "${cd}\db\intermediate\materia_r.dta", replace

	clear
	use "${pym}\y1994\producto.dta", clear
	drop if codigo==999
	replace valpro=valvfab
	gen N_prod=1
	collapse (sum) valorven valpro N_prod, by(nordest)
	save "${cd}\db\intermediate\producto_r.dta", replace	

	clear

*	______________

*	ii. Merge
*	______________
	
	
	*drop duplicates
	use "${pym}\y1994\dir94.dta", clear
	duplicates tag nordest, gen(tagl)
	drop if tagl==1
	drop tagl
	
	*merge	
	merge 1:1 nordest using "${cd}\db\intermediate\control94.dta"
	keep if cuadro==1
	tab _merge
	drop _merge
	rename act944 ciiu_r2
	rename fechaini anoper
	save "${cd}\db\intermediate\1994.dta", replace

	merge 1:1 nordest using "${cd}\db\intermediate\cap7i_r.dta"
	keep if cuadro==1
	tab _merge
	drop _merge
	save "${cd}\db\intermediate\1994.dta", replace

	merge 1:1 nordest using "${cd}\db\intermediate\cap8i_r.dta"
	keep if cuadro==1
	tab _merge
	drop _merge
	save "${cd}\db\intermediate\1994.dta", replace

	merge 1:1 nordest using "${cd}\db\intermediate\producto_r.dta"
	keep if cuadro==1
	tab _merge
	drop _merge
	save "${cd}\db\intermediate\1994.dta", replace

	merge 1:1 nordest using "${cd}\db\intermediate\materia_r.dta"
	keep if cuadro==1
	tab _merge
	drop _merge
	save "${cd}\db\intermediate\1994.dta", replace	
	
	merge 1:1 nordest using "${cd}\db\intermediate\nuevas94_r.dta"
	keep if cuadro==1
	tab _merge
	drop _merge
	keep if cuadro==1
	save "${cd}\db\intermediate\1994.dta", replace

*	_______________

*	iii. Clean
*	________________	


	gen year=1994
	format nitcc %12.0f 
	save "${cd}\db\intermediate\1994.dta", replace
	
	gen per_tot=valci88_8_5+valci87_8_5
	rename valqcons materiales

	gen ciiu3_r2=floor(ciiu_r2/10)
	replace ciiu3_r2=311 if ciiu3_r2==312
	
	saveold  "$cd/db/1994_reducida_EFX.dta", replace
	
	cap erase "${cd}\db\intermediate\1994.dta"
	cap erase "${cd}\db\intermediate\cap7i_r.dta"
	cap erase "${cd}\db\intermediate\cap8i_r.dta"
	cap erase "${cd}\db\intermediate\control94.dta"
	cap erase "${cd}\db\intermediate\materia_r.dta"
	cap erase "${cd}\db\intermediate\nuevas94_r.dta"
	cap erase "${cd}\db\intermediate\producto_r.dta"

	cap log close
