	cap n log close
	log using "$logfile_dir\2.10 Tables A3 & A4 (`c(current_date)').log", replace
	
	global sectors 311 313 314 321 322 323 324 331 332 341 342 351 352 355 356 361 362 369 371 372 381 382 383 384 385 390
	
	    			
	matrix Table_B1=J(1,13,0)
	matrix colnames Table_B1= sector Sk_Int_q1 Sk_Int_q2 Sk_Int_q3 Sk_Int_q4 Exp_firm_q1 Exp_firm_q2 Exp_firm_q3 Exp_firm_q4 Imp_firm_q1 Imp_firm_q2 Imp_firm_q3 Imp_firm_q4 
	
	matrix Table_B2=J(1,19,0)
	matrix colnames Table_B2= sector mean_Sk_int_88 mean_Sk_int_94  norm_rev_88 norm_rev_94 Sk_int_88_p5 Sk_int_88_p10 Sk_int_88_p25 Sk_int_88_p50 Sk_int_88_p75 Sk_int_88_p90 Sk_int_88_p95 ///
	                                                                                        Sk_int_94_p5 Sk_int_94_p10 Sk_int_94_p25 Sk_int_94_p50 Sk_int_94_p75 Sk_int_94_p90 Sk_int_94_p95
	matrix Table_B2_alt=J(1,3,0)
	matrix colnames Table_B2_alt= sector  norm_rev_88 norm_rev_94
	
foreach sector of global sectors {
	
	*==============================================================================================================================
	*       Variable Creation
	*==============================================================================================================================
	

	use "Other\trade_sic3_DNP.dta", clear
	rename fobpeso_ciiu_r2 EXP_
	rename cif_pesos IMP_
	
	rename sic3 ciiu3_r2
	keep if ciiu3_r2==`sector'
	tab ciiu3_r2

	reshape wide EXP_ IMP_, i(year) j(ciiu3_r2)
	save "$cd\exp_imp_DNP_`sector'.dta", replace
	
	use "$cd\db\EAM8288&94_EFX_Final.dta", clear
	keep if ciiu3_r2==`sector'
	tab ciiu3_r2
	
	cap drop _merge 
	merge m:1 year using "$cd\exp_imp_DNP_`sector'.dta" 
	drop if _merge==2
	drop _merge
	erase "$cd\exp_imp_DNP_`sector'.dta"
	replace IMP_`sector'=0 if IMP_`sector'==.
	replace EXP_`sector'=0 if EXP_`sector'==.
	
    
    gen nlndr=ln(tsales-esales)-ln(ts-EXP_`sector'+IMP_`sector')
	gen mshare=nlndr 
	gen nlnr_mi_exp=ln(tsales)-ln(ts-EXP_`sector'+IMP_`sector') 
	gen nlnr_mi=ln(tsales)-ln(ts+IMP_`sector') 
	gen nlnr=ln(tsales)-ln(ts) 
	
		
	 *--------------------------------------------------------------------------
		
		    gen lndr=ln(tsales-esales)
			label var lndr "log domestic sales (AMS)"
			
			gen lndr_sort=lndr if year<1992 // Variable defined for all the period.
			
	        gen  dumexp=1 if esales>0 & esales!=.
			replace dumexp=0 if esales==0
			
			gen  dumimp=1 if vfm>0 & vfm!=.
			replace dumimp=0 if vfm==0
	
	*--------------------------------------------------------------------------
	    * creating categories of size [Ycat]  ( by ln (domestic revenue)) and categories of Wage per worker [Wcat]  (by ln (wage per worker))
		
	
		foreach s in 1988 {
		
		xtile quart_y_`s'=lndr_sort if  year==`s' , n(4)	
	
		xtile quart_w_`s'=lnwpw if  year==`s', n(4)
		}
		
		gen ycat=.
		gen wcat=.
		
			
		foreach s in 1988 {
	
		replace ycat=quart_y_`s' if year==`s'
		
		replace wcat=quart_w_`s' if year==`s'
		drop quart_y_`s' quart_w_`s'
		}
	
	
			
	 *--------------------------------------------------------------------------
		
		    gen employment=wrk_swide+wrk_u
			bys  year : egen L_total_year=sum(employment)
			gen weigth_for_skill=employment/L_total_year
			gen skillpremwide_wL=weigth_for_skill*skillpremwide
			* aggregate skill intensity
			egen Total_Skill_Emp88= total(wrk_swide) if year==1988
			egen Total_Emp88=total(employment) if year==1988
			gen Agg_Skill_Int=Total_Skill_Emp88/Total_Emp88
			
		
	                               *************************  Generating Tables  ********************************
								   
	*==============================================================================================================================
	*II.  Unconditional distribution of log(normalized domestic sales)
	*==============================================================================================================================
		
	
	foreach year in 1988{
	
						
						
	*==============================================================================================================================
	* Joint distributions of sales with other characteristics (in %)
	*==============================================================================================================================
		
		*--------------------------------------------------------------------------
		*	Getting share of exporting & importing plants and Export intensity & import Intensity(export sales/total sales) by quartile of Ycat
		
		
			if "`year'"=="1988" {
			local export_sales esales
			}
			
			if "`year'"=="1988" {
			local imports_inputs vfm
			}
			
			*else {
			*local export_sales esalesD
			*}
			
			
			* % of exporters and % importers by quartile of domestic sales 
			preserve
			
			collapse (sum) dumexp dumimp (count) nplant=tsales, by (year ycat)
	            *% exporters
			gen eplant`year'=dumexp/nplant
			tabstat eplant`year' if year==`year', by (ycat) stat (mean) save
						
						matrix eshare`year'=[r(Stat1),r(Stat2),r(Stat3),r(Stat4)]
						
				* % importers
			gen iplant`year'=dumimp/nplant
			
			tabstat iplant`year' if year==`year', by (ycat) stat (mean) save
						
						matrix ishare`year'=[r(Stat1),r(Stat2),r(Stat3),r(Stat4)]
						
	        restore
			
			
		*==============================================================================================================================
	    *  Distribution of skill intensity (in %)
	    *==============================================================================================================================
	
		
					di " Unconditional Dist of skill intensity (i.e share of High skill labor)"	
						tabstat s_sharewide if year==`year' , stat (p5 p10 p25 p50 p75 p90 p95) save
						
			            matrix dists_sharewide`year'=r(StatTotal)'
						
						
					di " Non weighted mean of Skill intensity by quartile of Ycat (domestic revenue)"
					tabstat s_sharewide if year==`year', by (ycat) stat (mean) save
					
					matrix dists2_sharewide`year'=[r(Stat1),r(Stat2),r(Stat3),r(Stat4)]	
					
			         
		
	
		    *-------------------------------------
			* Aggregate Skill Intensity estimation
			*-------------------------------------
			
			egen Total_Skill_Emp`year'= total(wrk_swide) if year==`year'
			egen Total_Emp`year'=total(employment) if year==`year'
			gen Agg_Skill_Int`year'=Total_Skill_Emp`year'/Total_Emp`year'
		   	
			tabstat Agg_Skill_Int`year' ,  stat (mean) save 
			
			matrix Agg_skill_int`year'=r(StatTotal)'
	        
	
	          
		}
		
	    *==============================================================================================================================
	    * Changes in the distributions of sales and skill intensity
	    *==============================================================================================================================
	
		
		foreach year in 1988 1994 {
		
									
					preserve
					keep if year==`year'
					tabstat nlnr_mi_exp, stat(me) save
					matrix nlnrm`year'=r(StatTotal)'
					
					collapse (sum) tsales (mean)  EXP_`sector' IMP_`sector'
					gen tnr_me=tsales/(tsales +IMP_`sector'-EXP_`sector')
					tabstat tnr_me, stat (me) save
					matrix tnr_me`year'=r(StatTotal)'

				    restore		
		}	
		
		foreach year in 1994{
			        di " Unconditional Dist of skill intensity (i.e share of High skill labor)"	
						tabstat s_sharewide if year==`year' , stat ( p5 p10 p25 p50 p75 p90 p95 ) save
			            matrix dists_sharewide`year'=r(StatTotal)'
						
				di "Skill intensity weighted by L"		
		    egen Total_Skill_Emp`year'= total(wrk_swide) if year==`year'
			egen Total_Emp`year'=total(employment) if year==`year'
			gen Agg_Skill_Int`year'=Total_Skill_Emp`year'/Total_Emp`year'	 
		    tabstat Agg_Skill_Int`year' ,  stat (mean) save 
			matrix Agg_skill_int`year'=r(StatTotal)'
							
	 }
	    
		
				
		   matrix all_var_sect=[`sector' , dists2_sharewide1988 , eshare1988 , ishare1988]
		   matrix Table_B1=[Table_B1\all_var_sect]
		   
		   matrix all_var_sect2=[`sector' ,Agg_skill_int1988, Agg_skill_int1994,tnr_me1988, tnr_me1994 ,  dists_sharewide1988  , dists_sharewide1994 ]
		   matrix Table_B2=[Table_B2\all_var_sect2]
		   
		   matrix all_var_sect3=[`sector', nlnrm1988 ,nlnrm1994]
		   matrix Table_B2_alt=[Table_B2_alt\all_var_sect3]		   
}
		 
		   
		  
		   cap erase "$cd/Paper_EFX_Table_A3_BySector.xls"
		   cap erase "$cd/Paper_EFX_Table_A3_BySector.txt"
		   
		   xml_tab Table_B1 using "$cd/Paper_EFX_Table_A3_BySector.xls"
		   
		    cap erase "$cd/Paper_EFX_Table_A4_BySector.xls"
		    cap erase "$cd/Paper_EFX_Table_A4_BySector.txt"
		   
		   xml_tab Table_B2 using "$cd/Paper_EFX_Table_A4_BySector.xls"
		   xml_tab Table_B2_alt using "$cd/Paper_EFX_Table_A4_BySector.xls", append sheet(Alt- Firm size decrease)
