	cap n log close
	log using "$logfile_dir\2.11 Table A1 & A2 (`c(current_date)').log", replace
 
	pause on

	use "$cd\db\EAM8288&94_EFX_Final.dta", clear
		
	cap drop _merge 
	
	gen skill_prem=(wpw_skill/wpw_unskill)
	gen employment=wrk_swide+wrk_u
	*---------------------------------------------------------------------------
		
	cap erase "$cd\Paper_EFX_Table_A1_A2.xls"
	cap erase "$cd\Paper_EFX_Table_A1_A2.txt"	
	cap erase "$cd/AGP_EFX_descriptives.xls"
		
	foreach desag in 2 4 {
	
	if "`desag'"=="4" {
		local sic sic
		local digit 4
	}
	else if "`desag'"=="2" {
		local sic sic2
		local digit 2
	}
	
	preserve 
	
	gen ciiu4_r2=sic
	
	mmerge year ciiu4_r2 using "$cd/db/aran_ciiu.dta", type(n:1)
	drop if _merge==2
	drop _merge
	
	gen sic2=floor(sic/100)
	bys `sic' year: egen Lt=sum(employment)
	gen shL=employment/Lt
	gen sshw=s_sharewide*shL
	
	collapse (mean) tsales_real s_sharewide skill_prem aran_nom l_aran_nom (sum) agskill=sshw totsale=tsales_real employment, by(`sic' year) 
	replace aran_nom=aran_nom/100
	replace l_aran_nom=l_aran_nom/100
		
	xtset `sic' year
		
	gen lnsales=ln(tsales_real)
	gen lntotsale=ln(totsale)
		
	egen Lt=sum(employment)
	gen shL=employment/Lt
		
		
	foreach var in lnsales lntotsale aran_nom {
	
		cap n drop l6_`var'
		cap n drop f6_`var'
		cap n drop dif_`var'_94_88
		gen l6_`var' = l6.`var'	if year==1994
		gen f6_`var' = f6.`var'	if year==1988
		gen dif_`var'_94_88 = `var' - l6_`var' if year==1994
		replace dif_`var'_94_88 = f6_`var' - `var' if year==1988
	
	}
	
	
	gen ydif_aran=aran_nom-l_aran_nom
	gen iniagskill=agskill if year==1982
	bys `sic': egen iniskill_82=mean(iniagskill)
	gen fall_aran_94_88=-dif_aran_nom if year==1988
	gen agskill_88 = agskill if year==1988
	gen s_sharewide_88 = s_sharewide if year==1988
	gen skill_prem_88 = skill_prem if year==1988
	
	tab year
	gen dpos=0
	replace dpos=1 if year>1989
	gen dpos_l_aran_nom = dpos*l_aran_nom

	
	************ Descriptives **********
	
	matrix des_`sic' = [1,2]
	matrix colnames des_`sic' = Mean SD
		
	foreach var in fall_aran_94_88 agskill_88 s_sharewide_88 skill_prem_88 agskill s_sharewide skill_prem l_aran_nom {
	
		sum `var', det
		
		matrix des_`sic' = [des_`sic'\r(mean),r(sd)]
	
	}
	
	matrix rownames des_`sic' = one fall_aran_94_88 agskill_88 s_sharewide_88 skill_prem_88 agskill s_sharewide skill_prem l_aran_nom
	
	matrix des_`sic' = des_`sic'[2...,1...]
	
	mat2txt2 des_`sic' using "$cd/AGP_EFX_descriptives.xls",  append title("`digit'-digits sector level descriptives")

	***************************************
	
	foreach var in agskill_88 s_sharewide_88 skill_prem_88 {
	
		reg fall_aran_94_88 `var' if year==1988
		outreg2 `var' using "$cd\Paper_EFX_Table_A1_A2.xls", append addtext(Year FE, No, Sector FE, No, Agregation, `digit'-digits sector, Year, 1988)

	}
		
		if "`desag'"=="4" {
			local fe
			local outfe Year FE, No, Sector FE, No,
		}

		if "`desag'"=="2" {
			local fe i.`sic' i.year
			local outfe Year FE, Yes, Sector FE, Yes,
		}
				
		reg s_sharewide l_aran_nom `fe'
		outreg2 l_aran_nom using "$cd\Paper_EFX_Table_A1_A2.xls", append addtext(`outfe' Agregation, `digit'-digits sector, Year, 1982-1988 & 1994)

		
	restore
	
	}
		
	*---------------------------------------------------------------------------
	* Merge with Output and Input tariffs
	
	mmerge year nordest using "$cd/db/input_tariff8288_94.dta", type(1:1)
	tab year _merge
	drop if _merge==2
	
	mmerge year nordest using "$cd/db/output_tariff8288_94.dta", type(1:1)
	tab year _merge
	drop if _merge==2
	
	replace tariff_in=tariff_in/100
	replace tariff_out=tariff_out/100
	replace l_tariff_in = l_tariff_in/100
	replace l_tariff_out=l_tariff_out/100
	
	gen s_sharewide_88 = s_sharewide if year==1988
	gen skill_prem_88 = skill_prem if year==1988
	
	tab year
	gen dpos=0
	replace dpos=1 if year>1989
	gen dpos_l_tariff_out = dpos*l_tariff_out
	
	bys sic year: egen tariff_sec= mean(tariff_out) 
		
	xtset nordest year
			
	foreach var in ln_sales_real tariff_in tariff_out s_sharewide skill_prem tsales_real ln_sales_real {
	
	cap n drop l6_`var'
	cap n drop f6_`var'
	cap n drop dif_`var'_94_88
	gen l6_`var' = l6.`var'	if year==1994
	gen f6_`var' = f6.`var'	if year==1988
	gen dif_`var'_94_88 = `var' - l6_`var' if year==1994
	replace dif_`var'_94_88 = f6_`var' - `var' if year==1988
	
	}
	
	gen fall_tariff_out_94_88 = -dif_tariff_out_94_88 if year==1988

	*** Table A1 ***
	
	
	reg fall_tariff_out_94_88 s_sharewide_88 i.sic if year==1988
	outreg2 s_sharewide_88 using "$cd\Paper_EFX_Table_A1_A2.xls", append addtext(Year FE, No, Sector FE, Yes, Agregation, Plant level, Year, 1988)

	reg fall_tariff_out_94_88 skill_prem_88 i.sic if year==1988
	outreg2 skill_prem_88 using "$cd\Paper_EFX_Table_A1_A2.xls", append addtext(Year FE, No, Sector FE, Yes, Agregation, Plant level, Year, 1988)
		
	*** Table A2 ***

	reg s_sharewide l_tariff_out i.sic
	outreg2 l_tariff_out using "$cd\Paper_EFX_Table_A1_A2.xls", append addtext(Year FE, No, Sector FE, Yes, Agregation, Plant level, Year, 1982-1988 & 1994)

	reg s_sharewide l_tariff_out i.sic i.year
	outreg2 l_tariff_out using "$cd\Paper_EFX_Table_A1_A2.xls", append addtext(Year FE, No, Sector FE, Yes, Agregation, Plant level, Year, 1982-1988 & 1994)
	
	

	************* Desriptives ******************
	
		*	V. DESCRIPTIVE STATISTICS
	*=========================================================================
		
	matrix des_plant = [1,2]
	matrix colnames des_plant = Mean SD
		
	foreach var in fall_tariff_out_94_88 s_sharewide_88 skill_prem_88 s_sharewide skill_prem l_tariff_out {
	
	sum `var', det
	
	matrix des_plant = [des_plant\r(mean),r(sd)]
	
	}
	
	matrix rownames des_plant = one fall_tariff_out_94_88 s_sharewide_88 skill_prem_88 s_sharewide skill_prem l_tariff_out
	
	matrix des_plant = des_plant[2...,1...]
	
	mat2txt2 des_plant using "$cd/AGP_EFX_descriptives.xls",  append title("Plant level descriptives")

	cap erase "$cd\Paper_EFX_Table_A1_A2.txt"
	
	cap n log close
	
