
	cap n log close
	
	log using "$logfile_dir\2.4 Instruments (`c(current_date)').log", append

	* Saving Tariff by ciiu rev. 2 at 4 digits
	
	use "${aran}/Aranceles7414_man.dta", clear
	tabstat aran_nom if inrange(year,1982,1988) | inlist(year,1993,1994), by(year) s(mean sd)
	
	tabstat aran_nom if inrange(year,1982,1988), by(year) s(mean sd) save
	
	matrix tariff_stats = [r(Stat1)'\r(Stat2)'\r(Stat3)'\r(Stat4)'\r(Stat5)'\r(Stat6)'\r(Stat7)'\r(StatTotal)']

	tabstat aran_nom if year==1994, s(mean sd) save
	
	matrix tariff_stats = [tariff_stats\r(StatTotal)']
	matrix rownames tariff_stats = 1982 1983 1984 1985 1986 1987 1988 "1982-1988" 1994
	
	mat2txt2 tariff_stats using "$cd\tariff_descriptives.xls", title("Raw tariffs by customs codes, all manufacturing nandina codes (8 digits)") replace

	collapse aran_nom, by(year ciiu)
	rename ciiu ciiu4_r2
	xtset ciiu4_r2 year
	gen l_aran_nom = l.aran_nom
	tabstat aran_nom l_aran_nom if inrange(year,1982,1988) | inlist(year,1993,1994), by(year) s(mean sd)
	save "$cd/db/aran_ciiu.dta", replace	
	
	*********************************************************************************************************************************
		
	*=========================================
	*	I. INPUT TARIFFS AT PLANT-YEAR LEVEL
	*=========================================
	
	use "$cd/db/mat_price_prodlev8288_94.dta", clear
	keep if year!=1994
	gen valqcons=v1/ippm_88
	
	collapse (sum) valqcons, by(nordest norden ciiu4_r2)
	/**ciiu4_r2 is a 4 digit ciiu code present in materials database. Corresponds to the 4-digit ciiu for the respective material's code*/
	/* There is no variable in outputs database used in this joining that has the same name*/
	joinby ciiu4_r2 using "$cd/db/aran_ciiu.dta"
	keep if inrange(year,1982,1988) | inlist(year,1993,1994)
	
	collapse (mean) aran_nom [iw=valqcons], by(nordest norden year)
	rename aran_nom tariff_in
	
	xtset nordest year
	gen l_tariff_in = l.tariff_in
	tabstat tariff_in, by(year) s(mean sd)
	keep if inrange(year,1982,1988) | inlist(year,1994)

	tabstat tariff_in if year!=1994, by(year) s(mean sd) save
	
	matrix tariff_in_stats = [r(Stat1)'\r(Stat2)'\r(Stat3)'\r(Stat4)'\r(Stat5)'\r(Stat6)'\r(Stat7)'\r(StatTotal)']

	tabstat tariff_in if year==1994, s(mean sd) save
	
	matrix tariff_in_stats = [tariff_in_stats\r(StatTotal)']

	matrix rownames tariff_in_stats = 1982 1983 1984 1985 1986 1987 1988 "1982-1988" 1994
	
	mat2txt2 tariff_in_stats using "$cd\tariff_descriptives.xls", title("Material tariffs using consumption atemporals weights") append
	
	save "$cd/db/input_tariff8288_94.dta", replace
	keep if inrange(year,1982,1988)
	save "$cd/db/input_tariff8288.dta", replace
	
	
	*============================================
	*	III. PRODUCT TARIFFS AT PLANT-YEAR LEVEL
	*============================================
	
	use "$cd/db/out_price_prodlev8288_94.dta", clear
	keep if year!=1994
	rename ciu4 ciiu4_r2
	
	collapse (sum) r, by(nordest ciiu4_r2)
	/**ciiu4_r2 is a 4 digit ciiu code present in materials database. Corresponds to the 4-digit ciiu for the respective material's code*/
	/* There is no variable in outputs database used in this joining that has the same name*/
	joinby ciiu4_r2 using "$cd/db/aran_ciiu.dta"
	keep if inrange(year,1982,1988) | year==1993 | year==1994
	
	collapse (mean) aran_nom [iw=r], by(nordest year)
	rename aran_nom tariff_out
	xtset nordest year
	gen l_tariff_out = l.tariff_out
	tabstat tariff_out l_tariff_out, by(year) s(mean sd)
	drop if year==1993
	
	tabstat tariff_out if year!=1994, by(year) s(mean sd) save
	
	matrix tariff_out_stats = [r(Stat1)'\r(Stat2)'\r(Stat3)'\r(Stat4)'\r(Stat5)'\r(Stat6)'\r(Stat7)'\r(StatTotal)']
	
	tabstat tariff_out if year==1994, s(mean sd) save
	
	matrix tariff_out_stats = [tariff_out_stats\r(StatTotal)']
	matrix rownames tariff_out_stats = 1982 1983 1984 1985 1986 1987 1988 "1982-1988" 1994
	
	mat2txt2 tariff_out_stats using "$cd\tariff_descriptives.xls", title("Products tariffs using sales atemporals weights") append

	save "$cd/db/output_tariff8288_94.dta", replace

	cap n log close
