	cap n log close
	log using "$logfile_dir\2.5 q measure (`c(current_date)').log", append
	

	use "$cd/db/out_price_prodlev8288_94.dta", replace
	keep if year!=1994
	
	*============================
	*	I. Variable generation
	*============================

	cap n drop id_time
	egen id_time = group(nordest year)

	gen lnr_price_fixed = lnr + 4*ln_price_real
	
	tab year, gen(d_year)
	
	drop if nordest==. | codigo==.

	reghdfe lnr_price_fixed, abs(codigo, savefe)
	rename __hdfe1__ fecod
	gen lnr_price_fixedw=lnr_price_fixed-fecod
	

	sum lnr_price_fixedw, det
	reghdfe lnr_price_fixedw , abs(id_time, savefe)
	
	/** Plant*year effects
	predict k_imp_ai, u*/
	rename __hdfe1__ k_imp_ait_hdfe2s
	cap drop __hdfe2__

	
	xtset, clear
	
	preserve
	collapse k_* , by(nordest year)
	
	save "$cd/db/dshift.dta", replace
	restore	

	*============================
	*============================
	*
	*	For 1982-1988 and 1994
	*
	*============================
	*============================
		
	use "$cd/db/out_price_prodlev8288_94.dta", replace
	
	*============================
	*	I. Variable generation
	*============================

	gen lnr_price_fixed = lnr + 4*ln_price_real

	tab year, gen(d_year)
	
	drop if nordest==. | codigo==.
	
	
	cap n drop id_time
	egen id_time = group(nordest year)
	xtset id_time
		

	reghdfe lnr_price_fixed, abs(codigo, savefe)
	rename __hdfe1__ fecod
	gen lnr_price_fixedw=lnr_price_fixed-fecod
	
	
	sum lnr_price_fixedw, det
	reghdfe lnr_price_fixedw , abs(id_time, savefe)
	
	/** Plant*year effects
	predict k_imp_ai, u*/
	rename __hdfe1__ k_imp_ait_hdfe2s_94
	cap drop __hdfe2__


*	____________________________________________________________________________

* 	1994, Plant FE, ReghdFE
*	____________________________________________________________________________


	reghdfe lnr_price_fixed if year==1994, abs(codigo, savefe)
	rename __hdfe1__ fecod94
	gen lnr_price_fixedw94=lnr_price_fixed-fecod94 if year==1994
	
	sum lnr_price_fixedw94, det
	reghdfe lnr_price_fixedw94 if year==1994 , abs(nordest, savefe)
	
	/** Plant*year effects
	predict k_imp_ai, u*/
	rename __hdfe1__ k_imp_ait_hdfe2s_94_2
	cap drop __hdfe2__

	
	preserve
	collapse k_* , by(nordest year)
	
	save "$cd/db/dshift_94.dta", replace
	restore	
 	
	cap n log close
