	cap n log close
	log using "$logfile_dir\2.8 Tables 9 (`c(current_date)').log", replace


	*---------------------------------------------------------------------------	
	global ifall "inrange(year,1982,1988)"
	global if1988 "year==1988"
	
	*=============================================================
    *  I. Regressions using product prices
	*=============================================================
	
	use "$cd\db\EAM8288&94_EFX_Final.dta", clear
	
	mmerge year nordest using "$cd\db\out_price_prodlev8288_94.dta", type(1:n)
	drop if year==1994
	
	local samp_selec " s_sharewide!=. &  lnwpw!=. &  ln_sales!=. & shimp!=. &  D_i!=."
    gen sample_est=1 if `samp_selec'
	di "estimation sample"
	tab sample_est, miss
		
	cap n drop _merge
	merge m:1 nordest year using "$cd\db\dshift.dta"
	drop if _merge==2
	drop _merge
	
	cap erase "$cd/Paper_EFX_Table9.xls"
	cap erase "$cd/Paper_EFX_Table9.txt"
	
	foreach var in s_sharewide k_imp_ait_hdfe2s {

	reghdfe ln_price_real `var' if sample_est==1 & inrange(year,1982,1988), abs(sic year codigo) cluster(norden)
	outreg2 `var' using "$cd/Paper_EFX_Table9.xls", append addtext(Plant FE, No, Sector FE, Yes, Product FE, Yes, Year FE, Yes, Firm Cluster, Yes, Period, 1982-1988, Panel, A) 
		
	}

	
    *=============================================================
    *  II. Regressions using materials prices
	*=============================================================
		
	use "$cd\db\EAM8288&94_EFX_Final.dta", clear
	
	*---------------------------------------------------------------------------
	

	mmerge year nordest using "$cd\db\mat_price_prodlev8288_94.dta", type(1:n)
	drop if year==1994
	
	local samp_selec " s_sharewide!=. &  lnwpw!=. &  ln_sales!=. & shimp!=. &  D_i!=."
    gen sample_est=1 if `samp_selec'
	di "estimation sample"
	tab sample_est, miss
		
	cap n drop _merge
	merge m:1 nordest year using "$cd\db\dshift.dta"
	drop if _merge==2
	drop _merge
	
	global varlist s_sharewide k_imp_ait
	xtset nordest
			
	foreach var in s_sharewide k_imp_ait_hdfe2s {
	
	reghdfe ln_price_real `var' if sample_est==1 & inrange(year,1982,1988), abs(sic year codigo) cluster(norden)
	outreg2 `var' using "$cd/Paper_EFX_Table9.xls", append addtext(Plant FE, No, Sector FE, Yes, Product FE, Yes, Year FE, Yes, Firm Cluster, Yes, Period, 1982-1988, Panel, B) 
		
	}
	
	cap erase "$cd/Paper_EFX_Table9.txt"			   
	
	cap n log close
	
