	cap n log close
	log using "$logfile_dir\2.8 Tables 11 (`c(current_date)').log", replace

    *=============================================================
    *  I. Call database summarize
	*=============================================================
	
	use "$cd\db\EAM8288&94_EFX_Final.dta", clear
	
	xtset nordest year
	
	* Merge with q measure dataset
	
	mmerge year nordest using "$cd/db/dshift.dta", type(n:1)
	drop if _merge==2
	drop if year==1994

	mmerge year nordest using "$cd/db/dshift_94.dta", type(n:1)
	drop if _merge==2
	drop if year==1994

	*---------------------------------------------------------------------------
	
	global ifall "inrange(year,1982,1988)"
	global if1988 "year==1988"
	
	local text_1988 1988
	local text_all 1982-1988
	
	*=============================================================
	*  II.  REGRESSIONS FOR TABLE # 8
	*=============================================================	
			
	cap n erase "$cd/Paper_EFX_Table11.xls"
	cap n erase "$cd/Paper_EFX_Table11.txt"
	
	di "dependent variables"
	sum D_i shimp
	sum D_i shimp if shimp>0

	di "independent variables"
	sum s_sharewide ln_sales 
	sum s_sharewide ln_sales if shimp>0


	* Sector FE

		*reg 1 (Panel A)
		areg D_i s_sharewide ln_sales, absorb(sic)
		outreg2 s_sharewide ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, All, Period, 1982-1988, Sector FE, Yes, Year FE, No, Plant FE, No, Panel, A)

		*reg 1 (Panel A)
		areg D_i k_imp_ait_hdfe2s ln_sales, absorb(sic)
		outreg2 k_imp_ait_hdfe2s ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, All, Period, 1982-1988, Sector FE, Yes, Year FE, No, Plant FE, No, Panel, A)
		
		*reg 2 (Panel B)
		areg shimp s_sharewide ln_sales if shimp>0, absorb(sic)
		outreg2 s_sharewide ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, Importers, Period, 1982-1988, Sector FE, Yes, Year FE, No, Plant FE, No, Panel, B)
		
		*reg 2 (Panel B)
		areg shimp k_imp_ait_hdfe2s ln_sales if shimp>0, absorb(sic)
		outreg2 k_imp_ait_hdfe2s ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, Importers, Period, 1982-1988, Sector FE, Yes, Year FE, No, Plant FE, No, Panel, B)
			
	* No Sector FE

		*reg 1 (Panel A)
		reg D_i s_sharewide ln_sales
		outreg2 s_sharewide ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, All, Period, 1982-1988, Sector FE, No, Year FE, No, Plant FE, No, Panel, A)

		*reg 1 (Panel A)
		reg D_i k_imp_ait_hdfe2s ln_sales
		outreg2 k_imp_ait_hdfe2s ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, All, Period, 1982-1988, Sector FE, No, Year FE, No, Plant FE, No, Panel, A)
		
		*reg 2 (Panel B)
		reg shimp s_sharewide ln_sales if shimp>0
		outreg2 s_sharewide ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, Importers, Period, 1982-1988, Sector FE, No, Year FE, No, Plant FE, No, Panel, B)
		
		*reg 2 (Panel B)
		reg shimp k_imp_ait_hdfe2s ln_sales if shimp>0
		outreg2 k_imp_ait_hdfe2s ln_sales using "$cd/Paper_EFX_Table11.xls", append addtext(Plant type, Importers, Period, 1982-1988, Sector FE, No, Year FE, No, Plant FE, No, Panel, B)
	
	 cap n erase "$cd/Paper_EFX_Table11.txt"	
	 
cap n log close
	
