	
	cap log close
	pause on
	
	
	*--------------------------------------------------------------------
	log using  "$cd\logs\3.Creating_price_index_(`c(current_date)').log", replace
	
	
	* ===================================================================
	* I. Create Panel of Inputs (years=1982-2012)
	* ===================================================================
	
	* I.a Call Databases and merge Establishment's sector and no.
	
	
	* For years 1982-1991
	
	foreach year in 82 83 84 85 86 87 88 89 90 91 {
	dis "`year'"
	use "y19`year'\materia.dta", clear
	if "`year'"=="88"{
	rename valvmateria valqcons
	rename codmateria codmate
	rename cantmateria cantmate
	}
	keep norden codmate cantmate valqcons
	
	do "$cd\cleaning_db.do"
	save  "$cd\temp_database\Inp_`year'.dta", replace
	preserve
	
	*now we call the plant identifiers.
	use "$cd\norden_nordest.dta", clear
	keep if year==19`year'
	save "$cd\temp_database\sect_`year'.dta", replace
	
	restore
	
	count if norden==.

	merge m:1 norden using "$cd\temp_database\sect_`year'.dta" 
	* merging sector code and nordest key into inputs database
	di "count if nordest==."
	count if nordest==.
	tab _merge if nordest==.
	
	drop if _merge==1
	*adding sector codes
		
    save  "$cd\temp_database\Inp_`year'.dta", replace
	erase "$cd\temp_database\sect_`year'.dta"
	}
		
	* For years 1992-1999
	
	foreach year in 92 93 94 95 96 97 98 99 {
	use "y19`year'\materia.dta", clear
	if "`year'"=="92"{
	rename valmate valqcons
	rename codigo codmate
	rename nordest nores92
	}
	if "`year'"=="93" | "`year'"=="94"{
	rename codigo codmate
	rename umedpro umedmate
	}
	
	if `year'<=94 & `year'!=92{
	keep nordest codmate cantmate valqcons umedmate
	}
	else if `year'==92{
	keep nores92 codmate cantmate valqcons umedmate
	}
	else{
	keep nordest codmate cantmate valqcons 
	}
	
	do "$cd\cleaning_db.do"
	save  "$cd\temp_database\Inp_`year'.dta", replace
	preserve
	
	use "$cd\norden_nordest.dta", clear
	keep if year==19`year'
	
	* Here remember that for year 1992 the plant identifier is nores92 but in the datasets it is named as nordest
	if `year'==92{
	keep nores92 ciiu3_r2 nordest
	}
	else{
	keep nordest ciiu3_r2
	}
	save "$cd\temp_database\sect_`year'.dta", replace
	
	restore
	
	if `year'==92{
	merge m:1 nores92 using "$cd\temp_database\sect_`year'.dta" 
	}
	else{
	merge m:1 nordest using "$cd\temp_database\sect_`year'.dta" 
	}
	drop if _merge==1  /*dropping obs that the project's program had decided to drop*/
	gen year=19`year'
	
    save  "$cd\temp_database\Inp_`year'.dta", replace
	erase  "$cd\temp_database\sect_`year'.dta"
	}
	
	* For years 2000-2009
	
	foreach year in 00 01 02 03 04 05 06 07 08 09 10 11 12 {
	
	if `year'!="09"{
	use "y20`year'\materia.dta", clear
	}
	else if `year'=="09"{
	use "y2009_preliminar\materia.dta", clear
	}
	
	if `year'>=01 & `year'<=07{
	destring codmate, replace force
	}
	
	keep nordest codmate cantmate valqcons 
	
	do "$cd\cleaning_db.do"
	save  "$cd\temp_database\Inp_`year'.dta", replace
	preserve
	
	
	
	
	use "$cd\norden_nordest.dta", clear
	keep if year==20`year'
	*these correspond to fictitious observations created for firms present for last time in the previous year
	keep nordest ciiu3_r2
	save "$cd\temp_database\sect_`year'.dta", replace
	
	restore
	merge m:1 nordest  using "$cd\temp_database\sect_`year'.dta" 
	drop if _merge==1		/*dropping obs that we had decided to drop in project's main databse */
	gen year=20`year'
	
    save  "$cd\temp_database\Inp_`year'.dta", replace
	erase  "$cd\temp_database\sect_`year'.dta"
	}
	
	* I.b Append database
	
	use "$cd\temp_database\Inp_82.dta", clear
	
	foreach year in 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 00 01 02 03 04 05 06 07 08 09 10 11 12 {
	append using "$cd\temp_database\Inp_`year'.dta"
	}
	
	save "$cd\temp_database\Inp_82to09_1.dta", replace
	
	foreach year in 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 00 01 02 03 04 05 06 07 08 09 10 11 12 {
	erase "$cd\temp_database\Inp_`year'.dta"
	}
	
	
	* any observations missing nordest?
	 cap n  tabstat nordest if nordest==., by(year) stat(co)
	 tabstat nordest if nordest<0, by(year) stat(co)
	
		
	
   * summarize missings in input code
    di "next table shows the number of firms that are in the using (panel dbestablishment but were not in the master (input level db) "
    cap n tabstat year if codmate==., by(year) stat(co)
	tabstat year, by(year) stat(co)
	
	
	
	saveold "$cd\temp_database\Inp_82to12_1.dta", replace
	

	
	
 
	* ===================================================================
	* II. Unifying Product codes under CIIU & CPC
	* ===================================================================
	
	do "$cd\price index inputs - Unifying product codes.do"
	
	* ==================================================================================
	* III. Create required database structure: in any given year each plant in dataset
	*   has record for each of inputs it ever used, even if that input  not used in that
	*  particular year or if plant not present in that particular year but present before 
	*  and after ("gap" plants)
	* ================================================================================== 

	
	 use "$cd\temp_database\Inp_82to12_2.dta", clear
	 preserve
		*start by creating a small dataset listing inputs ever used by eah plant
	 duplicates drop  nordest codmate, force	
	 keep nordest codmate
	 drop if codmate==.
	 save "$cd\complete_set_inputs.dta", replace

	 restore
	 	
	 foreach year in 1982 1983 1984 1985 1986 1987 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 ///
	 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 {
	  preserve
	 keep if year==`year'
	 cap drop _merge
	 merge 1:1 nordest codmate using  "$cd\complete_set_inputs.dta"
	 bys nordest: egen m_year=max(year)
	 drop if m_year==.
	 *dropping plants that did not exist in the particular year
	 tab _merge
	 
	 * now filling missing values for norden and sector of plants that were in dbestablishment in the given year
	 foreach var in  norden ciiu3_r2{
	 bys nordest: egen m_`var'=max(`var')
	 }
	 foreach var in year norden ciiu3_r2 {
	 bys nordest: replace `var'= m_`var' if `var'==.
	 drop m_`var'
	 }
	 
	
	  save "$cd\complete_set_inputs_`year'.dta", replace
	  restore
	 }
	
	 
	 use "$cd\complete_set_inputs_1982.dta", clear
	 foreach year in 1983 1984 1985 1986 1987 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 {
	  append using "$cd\complete_set_inputs_`year'.dta"
	 }
	 
	 
	 foreach year in 1982 1983 1984 1985 1986 1987 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 {
	  erase "$cd\complete_set_inputs_`year'.dta"
	 }
	 drop _merge
	
	
	  drop if codmate==.
	  	  
	 save "$cd\temp_database\Inp_82to12_3_me.dta", replace
