
	* ===================================================================
	* II. Unifying Product codes under CIIU & CPC
	* ===================================================================
	
	* Note: Product codes are under CIIU (revision 2) nomenclature for years previous to 2001 and from 2001 onward ( at least up to 2009) they are under CPC nomenclature
	* Dane has given us a concordance table to unify all product codes under CPC nomenclature, Thus all product codes in 2000 and backward will be changed to CPC nomenclature.
	
	* next lines collapse those products that in 2000 and backwards were a single product and in 2001-2009 diverge into two separate
	* products
		clear matrix
		set matsize 11000
	  use "$other/Correlative_CPC_CIIU.dta", clear
	  *Correlativa_CPC has: new_code (CPC), old_code (CIIU), old_code_n (CIIU numeric rather than string), umed (units), 
	  *rep_newC (number of corresponding new codes an old code has, always=1), rep_oldC (same but for correspondence to new codes)
	  tab n_CPC n_ciiu
	  sort CIIU2
	  list CIIU2 CPC n_ciiu UD if n_CPC!=1
	  keep if n_CPC!=1
	  preserve
	  collapse (max) CPC, by(CIIU2)
	  mkmat CPC CIIU2, mat(recode_mat)
	  global aux=rowsof(recode_mat)
	  restore
	  matrix size= J($aux,1,0)
	  
	  forvalues j=1/$aux{
	  preserve
	  keep if CIIU2==recode_mat[`j',2]
	  drop if CPC==recode_mat[`j',1]  
	  mkmat CPC, mat(recode_prod_`j')
	  global aux2=rowsof(recode_prod_`j')
	  matrix size[`j',1]= $aux2
	  restore
	  }
	  
	  use "$cd\temp_database\Inp_82to12_1.dta", clear
	  
	  * Now make code replacements
	  forvalues j=1/$aux{
	  global aux3=size[`j',1]
	  forvalues k=1/$aux3{
	  global prod_code=recode_prod_`j'[`k',1]
	  global prod_code2=recode_mat[`j',1]
	  di "changing product code : $prod_code to $prod_code2 "
	  count if codmate==recode_prod_`j'[`k',1] & year>2000
	  * up to this point variable codigo is in CIIU up to 2000 and CPC from 2001
	  replace codmate=recode_mat[`j',1] if codmate==recode_prod_`j'[`k',1] & year>2000
	   }
	  }   
	  

	  * now collapse the new aggregate products 
      collapse (sum) cantmate valqcons (mean) norden ciiu3_r2, by(codmate nordest year)	  
	  
	   save "$cd\temp_database\Inp_82to12_2.dta", replace
	
	preserve
	  
	  * modify the concordance to recognize CPC corresponding to each old_code after working with duplicates above
	  * this part is inocuous in terms of results, but implies that later no merges are due to lack of correspondence rather than categories splitting up
	   use "$other/Correlative_CPC_CIIU.dta", clear
	     *Correlativa_CPC has: CPC (CPC), old_code (CIIU), CIIU2 (CIIU numeric rather than string), umed (units), 
		format CPC %8.0f
	   bys CIIU2: egen double max_CPC=max(CPC)
	   format max_CPC %8.0f
	   keep if  CPC==max_CPC
	   rename CIIU2 codmate
	   save "$other/Correlative_CPC_mod.dta", replace
	 
	  restore
	 
	 	
	* Now merge the database
	  cap drop _merge
	  * up to this point variable codigo is in CIIU up to 2000 and CPC from 2001
	  gen double codmate_post=codmate if year>2000
	  replace codmate=. if year>2000
	  
	  *Now merge the correspondence for pre-2001, so we have corresponding codes in CPC
	  merge m:1 codmate using "$other/Correlative_CPC_mod.dta", keepusing(CPC)
	  di "lets see how many codes didnt match: present in Outut but have no correspondence in correspondence table"
	  format codmate %12.0f
	  tab codmate if _merge==1 & year<=2000, m
	  tabstat valqcons if year<=2000 , by(_merge) stat(co me sum)
	  cap erase "$other/Correlative_CPC_mod.dta"
	  
	 di "how many obs do we have in pre 2000:"
     	 count if year<=2000
	  * dropping those codes from the correlative never used as Outputs
	  drop if _merge==2
	  drop _merge
	 	  
	*we now also have CPC which is CPC corresponding code for pre-2001 codigos
	 		
		di "observations deleted because not in the correlative"
		drop if CPC==. & codmate!=. & year<=2000 //
		
		replace codmate=CPC if year<=2000
		*now codigo is also in CPC
		replace codmate=codmate_post if year>2000
		drop CPC codmate_post
	* finally dropping those plants that never reported any Output (so we can't even calculate their shares)
	  bys nordest: egen max_code=max(codmate)
	  drop if max_code==.
	  cap n tabstat year if codmate==., by(year) stat(co)
		
	 save "$cd\temp_database\Inp_82to12_2.dta", replace
