! ======================================================================================
subroutine calc_123(x, obj, succ)
    use parameters_model
    implicit none
    
    real(8), dimension(n), intent(in) :: x
    real(8), intent(out) :: obj
    logical, intent(out) :: succ
    real(8) :: obj1, obj2, obj3
    real(8) :: x1(n1), x2(n2), x3(n3)
    
    ! --------------------------------------------------
    call xallto123(x, x1, x2, x3)
    call calc_obj1(x1, obj1, succ)
    call calc_obj2(x2, obj2)
    call calc_obj3(x3, obj3)
    
    obj = obj1 + obj2 + obj3
    
end subroutine calc_123
    
! ======================================================================================
    subroutine calc_obj1(x, obj, succ)
    use parameters_model
    implicit none

	real(8), dimension(n1), intent(in) :: x
    real(8), intent(out) :: obj
    logical, intent(out) :: succ
    real(8), dimension(n) :: xall
    integer(4) :: j
        
    ! -----------------------------------------------------------
    succ = .false.
    call xtoguess1(x)      ! recover parameters from x
    call gen_xfirms 
    call gen_xquality
    call equilibrium(succ)
    
    ! moments and firm characteristics
    call firmout1    
    call moments1(obj)
end subroutine calc_obj1


! ======================================================================================
subroutine calc_obj2(x, obj)
    use parameters_model
	implicit none

	real(8), dimension(n2), intent(in) :: x
    real(8), intent(out) :: obj
    real(8), dimension(n) :: xall
    logical, parameter :: succ = .true.
    integer(4) :: j
        
    ! -----------------------------------------------------
    call xtoguess2(x)       ! recover parameters from x
    
    ! moments and firm characteristics
    call firmout2
    call moments2(obj)
    
end subroutine calc_obj2

! ======================================================================================
subroutine calc_obj3(x, obj)
    use parameters_model
	implicit none

	real(8), dimension(n3), intent(in) :: x
    real(8), intent(out) :: obj
    real(8), dimension(n) :: xall
    logical, parameter :: succ = .true.
    real(8) :: auxobj
    integer(4) :: j
        
    ! -----------------------------------------------------
    ! recover parameters from x
    call xtoguess3(x)      
    
    ! moments and firm characteristics
    call firmout3
    call moments3(obj)
       
end subroutine calc_obj3


