!****************************************************************************
!	gen qgrid based on a normal distribution in [qlow, qup], truncated at percl and percu

subroutine  gen_qgrid
	use parameters_quality
    use numerical_libraries
	implicit none

	! internal variables
	integer(4) :: j
	real(8) :: aux1, aux2, percu, percl, se_q, interval

	! ----------------------------------------------------

	! normal distribution (more observations for lower q)
	percl = .1d0
	percu = .9d0
	aux1 = DNORIN(percl)
	aux2 = DNORIN(percu)
	se_q = (qup - qlow)/(aux2-aux1)
    
    ! qgrid with zero
	interval = (percu - percl)/real(sizeq-1.)
	do j = 1, sizeq
		aux1 = percl + real(j-1)*interval
		qgrid(j) = DNORIN(aux1)
	end do
	qgrid = se_q*(qgrid - qgrid(1)) + qlow
    
end subroutine  gen_qgrid

