 subroutine x123toall(xall, x1, x2, x3)
        use parameters_model
        implicit none
        
        real(8), dimension(n), intent(out) :: xall
        real(8), dimension(n1), intent(in) :: x1
        real(8), dimension(n2), intent(in) :: x2
        real(8), dimension(n3), intent(in) :: x3
        
        ! ------------------------------------
        !xall(1:3,5:10,15:18) 
        xall(1:3) = x1(1:3)
        xall(5:10) = x1(4:9)
        xall(14:16) = x1(10:12)
        xall(18) = x1(n1)
        xall(11:13) = x2(1:3)
        xall(17) = x2(4)
        xall(4) = x3(1)
    
 end subroutine x123toall
    
! =========================================================
 subroutine xallto123(xall, x1, x2, x3)
        use parameters_model
        implicit none
        real(8), dimension(n), intent(in) :: xall
        real(8), dimension(n1), intent(out) :: x1
        real(8), dimension(n2), intent(out) :: x2
        real(8), dimension(n3), intent(out) :: x3
        
        ! ------------------------------------
        x1(1:3) = xall(1:3)
        x1(4:9) = xall(5:10)
        x1(10:12) = xall(14:16)
        x1(n1) = xall(18)
        x2(1:3) = xall(11:13)
        x2(4) = xall(17)
        x3(n3) = xall(4)
    
    end subroutine xallto123
    
! =========================================================
subroutine  guesstoxall(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n), intent(out) :: x
    integer :: j
    ! -------------------------------------------
    
    x(1) = mu1
    x(2) = log(sigma1)
    x(3) = log(sigma2)
    x(4) = z3
    x(5) = log(f1)
    x(6) = log(f2)
    x(7) = fm
    x(8) = log(fmvar)
    x(9) = fx
    x(10) = log(fxvar)
    x(11) = l1
    x(12) = l2
    x(13) = log(skpremium)
    x(14) = log(qf)
    x(15) = log(yf)
    x(16) = log(qcf)
    x(17) = log(varpi)
    x(18) = log(nu)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1,n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine guesstoxall

! =========================================================
subroutine  xtoguessall(x) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
    z3 = x(4)
	f1 = exp(x(5))
    f2 = exp(x(6))
    fm = x(7)
    fmvar = exp(x(8))
    fx = x(9)
    fxvar = exp(x(10))
    l1 = x(11)
    l2 = x(12)
    skpremium = exp(x(13))
    qf = exp(x(14))
    yf = exp(x(15))
    qcf = exp(x(16))
    varpi = exp(x(17))
    nu = exp(x(18))
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    !aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguessall
   
! =========================================================
subroutine  xtoguess1(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n1), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
	f1 = exp(x(4))
    f2 = exp(x(5))
    fm = x(6)
    fmvar = exp(x(7))
    fx = x(8)
    fxvar = exp(x(9))
    qf = exp(x(10))
    yf = exp(x(11))
    qcf = exp(x(12))
    nu = exp(x(13))
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess1:'
        do j = 1, n1
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess1

! =========================================================
subroutine  xtoguess2(x) 
    use data_moments
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n2), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    l1 = x(1)
    l2 = x(2)
    skpremium = exp(x(3))
    varpi = exp(x(4))
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    !aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess2:'
        do j = 1, n2
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess2

! =========================================================
subroutine  xtoguess3(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n3), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    z3 = x(1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess3:', x
        stop
    end if
    
end subroutine xtoguess3
! =========================================================
subroutine  print_parameters
    use parameters_model
	use parameters_estimate
	implicit none
    ! -------------------------------------------
    
    print *, ' -------------------------------------------------- '
    print *, ' PARAMETERS'
    print *, 'nu     ', nu
    print *, 'mu1    ', mu1
    print *, 'sigma1 ', sigma1
    print *, 'sigma2 ', sigma2
    print *, 'z3     ', z3
    print *, 'f1     ', f1
    print *, 'f2     ', f2
    print *, 'fm     ', fm 
    print *, 'fmvar  ', fmvar
    print *, 'fx     ', fx
    print *, 'fxvar  ', fxvar
    print *, 'l1     ', l1
    print *, 'l2     ', l2
    print *, 'l3     ', l3
    print *, 'wh/wl  ', skpremium
    print *, 'qf     ', qf
    print *, 'yf     ', yf
    print *, 'Qcf    ', qcf
    print *, 'varpi	 ', varpi
    print *, ' ' 
    
end subroutine print_parameters


! Get new guess of x around an interval of original
! for parameters that cannot be non-negative, they are greater than 1/2 the original value. This constraint is probably not binding anywhere
! =========================================================
subroutine  newguess(interv, xg) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: interv
    real(8), dimension(n), intent(out) :: xg        ! xguess
    integer :: j
    real(8) :: aux1, rd(n)
    ! -------------------------------------------
    
    do j = 1, n
        call RANDOM_NUMBER(rd(j))
    end do
    
    mu1 = emu1 + 2.*interv(1)*(rd(1)-0.5)
    sigma1 = max(esigma1/2.,esigma1 + 2.*interv(2)*(rd(2)-0.5))   
    sigma2 = max(esigma2/2.,esigma2 + interv(3)*(rd(3)-0.5)/5.)  
    z3 = ez3 + 0.5*(rd(4)-0.5)
	f1 = max(ef1/2., ef1 + 2.*interv(5)*(rd(5)-0.5)) 
    f2 = max(ef2/2.,ef2 + interv(6)*(rd(6)-0.5))  
    fm = efm + interv(7)*(rd(7)-0.5)
    fmvar = max(efmvar/2.,efmvar + interv(8)*(rd(8)-0.5)) 
    fx = efx + interv(9)*(rd(9)-0.5)
    fxvar = max(efxvar/2.,fxvar + interv(10)*(rd(10)-0.5)) 
    l1 = el1 + 5.*interv(11)*(rd(11)-0.5)
    l2 = el2 + 10.*interv(12)*(rd(12)-0.5)
    skpremium = max(eskpremium/2.,eskpremium + 3.*interv(13)*(rd(13)-0.5)) 
    qf = max(eqf/2.,eqf + interv(14)*(rd(14)-0.5)) 
    yf = max(eyf/2.,eyf + interv(15)*(rd(15)-0.5)) 
    qcf = max(eqcf/2.,eqcf + interv(16)*(rd(16)-0.5)/10.) 
    varpi = max(evarpi/2.,evarpi + 5.*interv(17)*(rd(17)-0.5)) 
    nu = max(enu/2., enu + interv(18)*(rd(18)-0.5)/10.) 
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    !aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    call guesstoxall(xg)
    if (any(isnan(xg))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, xg(j)
        end do
        stop
    end if
    
end subroutine newguess

! =========================================================
! construct vector with x + and minus one standard deviation from xestimate
subroutine  gettol(x, myse, xtup, xtdown) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x, myse
    real(8), dimension(n), intent(out) :: xtup, xtdown      
    real(8), dimension(n) :: xup, xdown        
    integer :: j
    ! -------------------------------------------
    
    xtup = 0.d0
    xtdown = 0.d0
    call xtoguessall(x)
    
    mu1 = mu1 + myse(1)
    sigma1 = sigma1 + myse(2)
    sigma2 = sigma2 + myse(3)
    z3 = z3 + myse(4)
	f1 = f1 + myse(5)
    f2 = f2 + myse(6)
    fm = fm + myse(7)
    fmvar = fmvar + myse(8)
    fx = fx + myse(9)
    fxvar = fxvar + myse(10)
    l1 = l1 + myse(11)
    l2 = l2 + myse(12)
    skpremium = skpremium  + myse(13)
    qf = qf + myse(14)
    yf = yf + myse(15)
    qcf = qcf + myse(16)
    varpi = varpi + myse(17)
    nu = nu + myse(18)
    call guesstoxall(xup)
    
    if (any(isnan(xup))) then
        print *, 'parameters not a number, gettol:'
        stop
    end if
    
    
    call xtoguessall(x)
    mu1 = mu1 - myse(1)
    sigma1 = sigma1 - myse(2)
    sigma2 = sigma2 - myse(3)
    z3 = z3 - myse(4)
	f1 = f1 - myse(5)
    f2 = f2 - myse(6)
    fm = fm - myse(7)
    fmvar = fmvar - myse(8)
    fx = fx - myse(9)
    fxvar = fxvar - myse(10)
    l1 = l1 - myse(11)
    l2 = l2 - myse(12)
    skpremium = skpremium  - myse(13)
    qf = qf - myse(14)
    yf = yf - myse(15)
    qcf = qcf - myse(16)
    varpi = varpi - myse(17)
    nu = nu - myse(18)
    call guesstoxall(xdown)
    
    if (any(isnan(xdown))) then
        print *, 'parameters not a number down, gettol:'
        stop
    end if
    
    xtup = max(xup, xdown)
    xtdown = min(xup, xdown)
    
    open(1, FILE='mytol.csv', STATUS='REPLACE')
    write(1,*), 'xtdown, xtup'
    do j = 1, n    
        write(1,*), xtdown(j), ', ', xtup(j)
    end do
    close(1)
end subroutine gettol

! =====================================================
 subroutine setdelta(x0, xup, xdown)
        use parameters_model
        use parameters_sanneal
        implicit none
        
        real(8), dimension(n), intent(in) :: xup, xdown, x0
        
        ! ------------------------------------
        !delta123 = min(xup - x0, x0 - xdown)/2.        ! delta is one standard deviation approximately
        delta123 = (xup - xdown)        ! delta is four standard deviation approximately
        delta123(3) = delta123(3)*1.e-3; delta123(6) = delta123(6)*1.e-2; delta123(14) = delta123(14)*1.e-3; delta123(15:16) = delta123(15:16)*1.e-2; delta123(18) = delta123(18)*1.e-1; 
        delta1(1:3) = delta123(1:3)
        delta1(4:9) = delta123(5:10)
        delta1(10:12) = delta123(14:16)
        delta1(n1) = delta123(18)
        delta2(1:3) = delta123(11:13)
        delta2(4) = delta123(17)
        delta3(n3) = delta123(4)
        
        mydelta1 = delta1
        mydelta2 = delta2
        mydelta3 = delta3
        
        call setdelta1; call setdelta2; call setdelta3; call setdelta123
 end subroutine setdelta
 
 subroutine setdelta1
        use parameters_model
        use parameters_polytope1
        implicit none
        
        usual_delta = delta1
 end subroutine setdelta1
 
 subroutine setdelta2
        use parameters_model
        use parameters_polytope2
        implicit none
        
        usual_delta = delta2
 end subroutine setdelta2
 
 subroutine setdelta3
        use parameters_model
        use parameters_polytope3
        implicit none
        
        usual_delta = delta3
 end subroutine setdelta3
 
 
 subroutine setdelta123
        use parameters_model
        use parameters_polytopeall
        implicit none
        
        usual_delta = delta123
 end subroutine setdelta123
 
 ! ==========================================================
 ! calculate distance between parameters of x and estimated parameters
 
 subroutine distpar(x, distl, distp)
 use parameters_model
 use parameters_estimate
 implicit none
 
 ! Variables
 real(8), dimension(n), intent(in) :: x
 real(8), intent(out) :: distl, distp
 real(8), dimension(n) :: vdistl, vdistp
 
 ! =============================================
 call xtoguessall(x)
 
    vdistl(1) = abs(mu1 - emu1)
    vdistl(2) = abs(esigma1 - sigma1)
    vdistl(3) = abs(esigma2 - sigma2)
    vdistl(4) = abs(ez3 - z3)
	vdistl(5) = abs(ef1 - f1)
    vdistl(6) = abs(ef2 - f2)
    vdistl(7) = abs(efm - fm)
    vdistl(8) = abs(efmvar - fmvar)
    vdistl(9) = abs(efx - fx)
    vdistl(10) = abs(efxvar - fxvar)
    vdistl(11) = abs(el1 - l1)
    vdistl(12) = abs(el2 - l2)
    vdistl(13) = abs(eskpremium - skpremium)
    vdistl(14) = abs(eqf - qf)
    vdistl(15) = abs(eyf - yf)
    vdistl(16) = abs(eqcf - qcf)
    vdistl(17) = abs(evarpi - varpi)
    vdistl(18) = abs(enu - nu)
    
    
    vdistp(1) = abs(mu1 - emu1)/abs(mu1)
    vdistp(2) = abs(esigma1 - sigma1)/abs(sigma1)
    vdistp(3) = abs(esigma2 - sigma2)/abs(sigma2)
    vdistp(4) = abs(ez3 - z3)/abs(z3)
	vdistp(5) = abs(ef1 - f1)/abs(f1)
    vdistp(6) = abs(ef2 - f2)/abs(f2)
    vdistp(7) = abs(efm - fm)/abs(fm)
    vdistp(8) = abs(efmvar - fmvar)/abs(fmvar)
    vdistp(9) = abs(efx - fx)/abs(fx)
    vdistp(10) = abs(efxvar - fxvar)/abs(fxvar)
    vdistp(11) = abs(el1 - l1)/abs(l1)
    vdistp(12) = abs(el2 - l2)/abs(l2)
    vdistp(13) = abs(eskpremium - skpremium)/abs(skpremium)
    vdistp(14) = abs(eqf - qf)/abs(qf)
    vdistp(15) = abs(eyf - yf)/abs(yf)
    vdistp(16) = abs(eqcf - qcf)/abs(qcf)
    vdistp(17) = abs(evarpi - varpi)/abs(varpi)
    vdistp(18) = abs(enu - nu)/abs(nu)
    
    !print *, 'parameter distance min, max, avg'
    !print *, 'lv', minval(vdistl), maxval(vdistl), sum(vdistl)/n
    !print *, '% ', minval(vdistp), maxval(vdistp), sum(vdistp)/n
    distl = sum(vdistl)/n
    distp = sum(vdistp)/n
    
    
 end subroutine distpar
 
 
 
 