 subroutine x123toall(xall, x1, x2, x3)
        use parameters_model
        implicit none
        
        real(8), dimension(n), intent(out) :: xall
        real(8), dimension(n1), intent(in) :: x1
        real(8), dimension(n2), intent(in) :: x2
        real(8), dimension(n3), intent(in) :: x3
        
        ! ------------------------------------
        !xall(1:3,5:10,15:18) 
        xall(1:2) = x1(1:2)
        xall(4:8) = x1(3:7)
        xall(12:14) = x1(8:10)
        xall(16) = x1(n1)
        xall(9:11) = x2(1:3)
        xall(15) = x2(4)
        xall(3) = x3(1)
    
 end subroutine x123toall
    
! =========================================================
 subroutine xallto123(xall, x1, x2, x3)
        use parameters_model
        implicit none
        real(8), dimension(n), intent(in) :: xall
        real(8), dimension(n1), intent(out) :: x1
        real(8), dimension(n2), intent(out) :: x2
        real(8), dimension(n3), intent(out) :: x3
        
        ! ------------------------------------
        x1(1:2) = xall(1:2)
        x1(3:7) = xall(4:8)
        x1(8:10) = xall(12:14)
        x1(n1) = xall(16)
        x2(1:3) = xall(9:11)
        x2(4) = xall(15)
        x3(n3) = xall(3)
    
    end subroutine xallto123
    
! =========================================================
subroutine  guesstoxall(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n), intent(out) :: x
    integer :: j
    ! -------------------------------------------
    
    x(1) = mu1
    x(2) = log(sigma1)
    x(3) = z3
    x(4) = log(f1)
    x(5) = fm
    x(6) = log(fmvar)
    x(7) = fx
    x(8) = log(fxvar)
    x(9) = l1
    x(10) = l2
    x(11) = log(skpremium)
    x(12) = log(qf)
    x(13) = log(yf)
    x(14) = log(qcf)
    x(15) = log(varpi)
    x(16) = log(nu)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1,n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine guesstoxall

! =========================================================
subroutine  xtoguessall(x) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    z3 = x(3)
	f1 = exp(x(4))
    fm = x(5)
    fmvar = exp(x(6))
    fx = x(7)
    fxvar = exp(x(8))
    l1 = x(9)
    l2 = x(10)
    skpremium = exp(x(11))
    qf = exp(x(12))
    yf = exp(x(13))
    qcf = exp(x(14))
    varpi = exp(x(15))
    nu = exp(x(16))
    aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguessall
   
! =========================================================
subroutine  xtoguess1(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n1), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
	f1 = exp(x(3))
    fm = x(4)
    fmvar = exp(x(5))
    fx = x(6)
    fxvar = exp(x(7))
    qf = exp(x(8))
    yf = exp(x(9))
    qcf = exp(x(10))
    nu = exp(x(11))
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess1:'
        do j = 1, n1
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess1

! =========================================================
subroutine  xtoguess2(x) 
    use data_moments
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n2), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    l1 = x(1)
    l2 = x(2)
    skpremium = exp(x(3))
    varpi = exp(x(4))
    aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess2:'
        do j = 1, n2
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess2

! =========================================================
subroutine  xtoguess3(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n3), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    z3 = x(1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess3:', x
        stop
    end if
    
end subroutine xtoguess3
! =========================================================
subroutine  print_parameters
    use parameters_model
	use parameters_estimate
	implicit none
    ! -------------------------------------------
    
    print *, ' -------------------------------------------------- '
    print *, ' PARAMETERS'
    print *, 'nu     ', nu
    print *, 'mu1    ', mu1
    print *, 'sigma1 ', sigma1
    print *, 'sigma2 ', sigma2
    print *, 'z3     ', z3
    print *, 'f1     ', f1
    print *, 'f2     ', f2
    print *, 'fm     ', fm 
    print *, 'fmvar  ', fmvar
    print *, 'fx     ', fx
    print *, 'fxvar  ', fxvar
    print *, 'l1     ', l1
    print *, 'l2     ', l2
    print *, 'l3     ', l3
    print *, 'wh/wl  ', skpremium
    print *, 'qf     ', qf
    print *, 'yf     ', yf
    print *, 'Qcf    ', qcf
    print *, 'varpi	 ', varpi
    print *, ' ' 
    
end subroutine print_parameters


! Get new guess of x around an interval of original
! for parameters that cannot be non-negative, they are greater than 1/2 the original value. This constraint is probably not binding anywhere
! =========================================================
subroutine  newguess(x, interv, xg) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x, interv
    real(8), dimension(n), intent(out) :: xg        ! xguess
    integer :: j
    real(8) :: aux1, rd(n)
    ! -------------------------------------------
    
    call xtoguessall(x)
    do j = 1, n
        call RANDOM_NUMBER(rd(j))
    end do
    
    mu1 = mu1 + interv(1)*(rd(1)-0.5)
    sigma1 = max(sigma1/2.,sigma1 + interv(2)*(rd(2)-0.5)) 
    z3 = z3 + interv(3)*(rd(3)-0.5)
	f1 = max(f1/2.,f1 + interv(4)*(rd(4)-0.5)) 
    fm = fm + interv(5)*(rd(5)-0.5)
    fmvar = max(fmvar/2.,fmvar + interv(6)*(rd(6)-0.5)) 
    fx = fx + interv(7)*(rd(7)-0.5)
    fxvar = max(fxvar/2.,fxvar + interv(8)*(rd(8)-0.5)) 
    l1 = l1 + interv(9)*(rd(9)-0.5)
    l2 = l2 + interv(10)*(rd(10)-0.5)
    skpremium = max(skpremium/2.,skpremium + interv(11)*(rd(11)-0.5)) 
    qf = max(qf/2.,qf + interv(12)*(rd(12)-0.5)) 
    yf = max(yf/2.,yf + interv(13)*(rd(13)-0.5)) 
    qcf = max(qcf/2.,qcf + interv(14)*(rd(14)-0.5)) 
    varpi = max(varpi/2.,varpi + interv(15)*(rd(15)-0.5)) 
    nu = max(nu/2.,nu + interv(16)*(rd(16)-0.5)) 
    aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    call guesstoxall(xg)
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine newguess

! =========================================================
! construct vector with x + and minus one standard deviation from xestimate
subroutine  gettol(x, myse, xtup, xtdown) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x, myse
    real(8), dimension(n), intent(out) :: xtup, xtdown      
    real(8), dimension(n) :: xup, xdown        
    integer :: j
    ! -------------------------------------------
    
    xtup = 0.d0
    xtdown = 0.d0
    call xtoguessall(x)
    
    mu1 = mu1 + myse(1)
    sigma1 = sigma1 + myse(2)
    z3 = z3 + myse(3)
	f1 = f1 + myse(4)
    fm = fm + myse(5)
    fmvar = fmvar + myse(6)
    fx = fx + myse(7)
    fxvar = fxvar + myse(8)
    l1 = l1 + myse(9)
    l2 = l2 + myse(10)
    skpremium = skpremium  + myse(11)
    qf = qf + myse(12)
    yf = yf + myse(13)
    qcf = qcf + myse(14)
    varpi = varpi + myse(15)
    nu = nu + myse(16)
    call guesstoxall(xup)
    
    if (any(isnan(xup))) then
        print *, 'parameters not a number, gettol:'
        stop
    end if
    
    
    call xtoguessall(x)
    mu1 = mu1 - myse(1)
    sigma1 = sigma1 - myse(2)
    z3 = z3 - myse(3)
	f1 = f1 - myse(4)
    fm = fm - myse(5)
    fmvar = fmvar - myse(6)
    fx = fx - myse(7)
    fxvar = fxvar - myse(8)
    l1 = l1 - myse(9)
    l2 = l2 - myse(10)
    skpremium = skpremium  - myse(11)
    qf = qf - myse(12)
    yf = yf - myse(13)
    qcf = qcf - myse(14)
    varpi = varpi - myse(15)
    nu = nu - myse(16)
    call guesstoxall(xdown)
    
    if (any(isnan(xdown))) then
        print *, 'parameters not a number down, gettol:'
        stop
    end if
    
    xtup = max(xup, xdown)
    xtdown = min(xup, xdown)
    
    open(1, FILE='mytol.csv', STATUS='REPLACE')
    write(1,*), 'xtdown, xtup'
    do j = 1, n    
        write(1,*), xtdown(j), ', ', xtup(j)
    end do
    close(1)
end subroutine gettol

! =====================================================
 subroutine setdelta(x0, xup, xdown)
        use parameters_model
        use parameters_sanneal
        implicit none
        
        real(8), dimension(n), intent(in) :: xup, xdown, x0
        
        ! ------------------------------------
        !delta123 = min(xup - x0, x0 - xdown)/2.        ! delta is one standard deviation approximately
        delta123 = (xup - xdown)/4.        ! delta is one standard deviation approximately
        delta1(1:2) = delta123(1:2)
        delta1(3:7) = delta123(4:8)
        delta1(8:10) = delta123(12:14)
        delta1(n1) = delta123(16)
        delta2(1:3) = delta123(9:11)
        delta2(4) = delta123(15)
        delta3(n3) = delta123(3)
        
        mydelta1 = delta1
        mydelta2 = delta2
        mydelta3 = delta3
        
        call setdelta1; call setdelta2; call setdelta3; call setdelta123
 end subroutine setdelta
 
 subroutine setdelta1
        use parameters_model
        use parameters_polytope1
        implicit none
        
        usual_delta = delta1
 end subroutine setdelta1
 
 subroutine setdelta2
        use parameters_model
        use parameters_polytope2
        implicit none
        
        usual_delta = delta2
 end subroutine setdelta2
 
 subroutine setdelta3
        use parameters_model
        use parameters_polytope3
        implicit none
        
        usual_delta = delta3
 end subroutine setdelta3
 
 
 subroutine setdelta123
        use parameters_model
        use parameters_polytopeall
        implicit none
        
        usual_delta = delta123
end subroutine setdelta123