    ! ---------------------------------------------------------------------
    ! returns a vector with results from phi function
    ! ---------------------------------------------------------------------
    subroutine phiv0(sizev, qvdiff, phivo)
    implicit none
    
    integer(4), intent(in) :: sizev
    real(8), dimension(sizev), intent(in) :: qvdiff         ! vector with q'-q (input quality - output or reference quality)
    real(8), dimension(sizev), intent(out) :: phivo         ! output vector with phi function
    
    ! ---------------------------------------------------------------------
    phivo = exp(qvdiff)/( 1. + exp(qvdiff) )
    
    end subroutine phiv0
    
    ! ---------------------------------------------------------------------
    ! returns a scalar with results from phi function
    ! ---------------------------------------------------------------------
    subroutine phir0(qdiff, phiro)
    implicit none
    
    real(8), intent(in) :: qdiff         ! vector with q'-q (input quality - output or reference quality)
    real(8), intent(out) :: phiro         ! output vector with phi function
    
    ! ---------------------------------------------------------------------
    phiro = exp(qdiff)/( 1. + exp(qdiff) )
    
    end subroutine phir0