subroutine calc_obj1(x, obj, succ)
    use parameters_model
    implicit none

	real(8), dimension(n1), intent(in) :: x
    real(8), intent(out) :: obj
    logical, intent(out) :: succ
    real(8), dimension(n) :: xall
    integer(4) :: j
        
    ! ======================================================================================
    ! construct primitives from the economy--independent of equilibrium outcomes
    ! -----------------------------------------------------------------------------------
    succ = .false.
       
    ! recover parameters from x
    call xtoguess1(x)   
    
    ! construct distribution of firms' productivity and fixed cost parameters
    ! subroutines in gen_qfffixed (quality, firms, foreign)
    ! ------------------------------------------------------
    call gen_xfirms          ! firm productivity, fixed import and export cost
    call gen_xquality
    
    ! -----------------------------------------------------
    call equilibrium(succ)
    
    ! moments and firm characteristics
    ! -----------------------------------------------------
    call firmout1
    
    call moments1(obj)
    
    
end subroutine calc_obj1


