! read initial guesses, random variables, and standard errors from data

! ==========================================================================
! initial guesses
! ==========================================================================
subroutine  read_initial(x)
	use parameters_firm
    use parameters_quality
    implicit none

    real(8), dimension(n), intent(out) :: x
    integer(4) :: j
	real(8) :: aux
    logical :: auxl

	! ----------------------------------------------------
    ! read equilibrium posqomega, bigpq, chiq
    open(1, FILE='mar17I.txt', STATUS='OLD')      ! change in weight of skill intensity + bigger punishment for lack of spread in skill intensity
    open(1, FILE='may17I.txt', STATUS='OLD')      ! change in weight of skill intensity + bigger punishment for lack of spread in skill intensity
    
    
    read(1,*), aux
    read(1,*), auxl
	do j = 1, n
        read(1,*), x(j) 
    end do
	do j = 1, sizef
		read(1,*), posqomega(j)
	end do
	do j = 1, sizef
		read(1,*), discreted(j)
	end do
	do j = 1, sizeq
		read(1,*), priceqh(j)
    end do
	do j = 1, sizeq
		read(1,*), intermediatechi(j)
	end do
	close(1)
      
end subroutine  read_initial 

! =====================================================================    
subroutine read_random
    use numerical_libraries
    use random_draw
    implicit none    
    
    integer(4) :: j, j1
    real(8) :: rd
    ! -----------------------------------------------
    ! to get truncated distributions, add after read rd: rd = rd*.95; rd = rd*.90 + .05
    
    !open(1, FILE='runiform.dat', STATUS='OLD')
    open(1, FILE='runiform_long.dat', STATUS='OLD')
    
    ! firm productivity
    do j1 = 1, 2
        do j = 1, sizef
            read(1,*), rd
		    random_firms(j,j1) = DNORIN(rd)       ! transforms uniform into standard normal
        end do
	end do
        
    ! importing and exporting fixed costs
    do j1 = 1, 2
        do j = 1, sizef
            read(1,*), rd
		    random_fxcost(j,j1) = DNORIN(rd)	 ! transforms uniform into standard normal
        end do
	end do
    
    ! measurement error in skills
    do j = 1, sizef
        read(1,*), rd
		random_skill(j) = rd					  ! truncated logistic
	end do
	close(1)
     
    ! create file with random draws
    ! -----------------------------
    !rdseed = 5
	!call random_seed(PUT = rdseed)
    !j = 100000
    !open(1, FILE='runiform.dat', STATUS='REPLACE')
    !do j1 = 1, j
    !    call RANDOM_NUMBER(rd)
    !    write(1,*), rd
    !end do
    !write(1,*), 'contains', j, 'draws from uniform'
    !close(1)
    !stop
    
    
    !print *, '---------------------------------------------------------- '
    !print *, 'summary of random variables: mean and variance'
    !print *, 'z		', sum(random_firms)/(2.*sizef), sum(random_firms**2.)/(2.*sizef)
    !print *, 'fm, fx', sum(random_fxcost)/(2.*sizef), sum(random_fxcost**2.)/(2.*sizef)
    !print *, 'skill ', sum(random_skill)/sizef, sum( (random_skill - 0.5d0)**2.)/sizef
    !print *, ' ' 
    
end subroutine read_random
