
! =========================================================
subroutine  xtoguess(x) 
    use parameters_model
	use parameters_estimate
    implicit none

    real(8), dimension(n), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
    f1 = exp(x(5))
    f2 = exp(x(6))
    fm = x(7)
    fmvar = exp(x(8))
    fx = x(9)
    fxvar = exp(x(10))
    qf = exp(x(14))
    yf = exp(x(15))
    qcf = exp(x(16))
    nu = exp(x(18))
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess


! =========================================================
subroutine  print_parameters
    use parameters_model
	use parameters_estimate
	implicit none
    
    print *, ' -------------------------------------------------- '
    print *, ' PARAMETERS'
    print *, 'nu     ', nu
    print *, 'mu1    ', mu1
    print *, 'sigma1 ', sigma1
    print *, 'sigma2 ', sigma2
    print *, 'f1     ', f1
    print *, 'f2     ', f2
    print *, 'fm     ', fm 
    print *, 'fmvar  ', fmvar
    print *, 'fx     ', fx
    print *, 'fxvar  ', fxvar
    print *, 'qf     ', qf
    print *, 'yf     ', yf
    print *, 'Qcf    ', qcf
    print *, ' ' 
    
end subroutine print_parameters