
use `1', clear

gen lntsales0 = ln(ntsales0)
gen lntsales1 = ln(ntsales1)
label var lntsales0 "log(total sales), norm. initial"
label var lntsales1 "log(total sales), norm. counterfactual"
twoway kdensity lntsales0 || kdensity lntsales1, legend(order( - "kernel density of log(sales)" - " " 1 "initial" 2 "counterfactual"))
pause

* classify firms by type and plot changes in quality
gen ftype = 0
replace ftype = 1 if (discreted0 >0 ) & (discreted1 == 1)
replace ftype = 2 if (discreted0 > 1 ) & (discreted1 == 2)
replace ftype = 3 if (discreted0 >= 3) & (discreted1 == 3)
replace ftype = 3 if (discreted0 == 4) & (discreted1 == 4)
replace ftype = 4 if (discreted0 == 1) & (discreted1 == 2)
replace ftype = 4 if (discreted0 == 3) & (discreted1 == 4)
replace ftype = 5 if (discreted0 == 1) & (discreted1 >= 3)
replace ftype = 5 if (discreted0 == 2) & (discreted1 == 4)

tabulate ftype

twoway scatter quality1 quality0 if ftype == 1, msize(small) msymbol(o) ///
|| scatter quality1 quality0 if ftype == 2, msize(small) msymbol(d) ///
|| scatter quality1 quality0 if ftype == 3, msize(small) msymbol(t) ///
|| scatter quality1 quality0 if ftype == 4, msize(small) msymbol(s) /// 
|| scatter quality1 quality0 if ftype == 5, msize(small) msymbol(+) ///
|| line quality0 quality0, lcolor(black) lwidth(thin) || line quality1 quality1, lcolor(black) lwidth(thin) ///
legend(order(1 "domestically-oriented firms" 2 "continuing importers" 3 "continuing exporters" 4 "new importers" 5 "new exporters")) ytitle("counterfactual quality") xtitle("initial quality")
pause

gen dlntsales = lntsales1 - lntsales0
/* twoway scatter dlntsales lntsales0 if ftype == 1, msize(small) msymbol(o) ///
|| scatter dlntsales lntsales0 if ftype == 2, msize(small) msymbol(d) ///
|| scatter dlntsales lntsales0 if ftype == 3, msize(small) msymbol(t) ///
|| scatter dlntsales lntsales0 if ftype == 4, msize(small) msymbol(s) /// 
|| scatter dlntsales lntsales0 if ftype == 5, msize(small) msymbol(+) ///
legend(order(1 "domestically-oriented firms" 2 "continuing importers" 3 "continuing exporters" 4 "new importers" 5 "new exporters")) ytitle("log change in sales") xtitle("initial log(sales)")
* pause
*/

twoway scatter dlntsales skilla0 if ftype == 1, msize(small) msymbol(o) ///
|| scatter dlntsales skilla0 if ftype == 2, msize(small) msymbol(d) ///
|| scatter dlntsales skilla0 if ftype == 3, msize(small) msymbol(t) ///
|| scatter dlntsales skilla0 if ftype == 4, msize(small) msymbol(s) /// 
|| scatter dlntsales skilla0 if ftype == 5, msize(small) msymbol(+) ///
legend(order(1 "domestically-oriented firms" 2 "continuing importers" 3 "continuing exporters" 4 "new importers" 5 "new exporters")) ytitle("log change in sales") xtitle("initial skill intensity")
* pause

exit
