subroutine calc_objcinq(x, obj, succ)
    use parameters_model
    use parameters_estimate
    use counterfactual
    use parameters_firm
    use parameters_quality
	implicit none
    ! =============================================
    
	real(8), dimension(nci), intent(in) :: x
    real(8), intent(out) :: obj
    logical, intent(out) :: succ
    integer(4) :: j
    real(8), dimension(sizeq) :: phihl, aux1, wq0
    
    ! -----------------------------------------------------------------------------------
    succ = .false.
       
    ! recover parameters from x, same parameters as counterEL
    call xtoguessci(x)      
    
    ! new prices, yfactor
    pf = pf0*(1+tariff1)/(1+tariff0)*pfactor
    yf = yf0*yfactor
    income = income0*ycfactor
    nfirms_data = nfirms_data1
    discreted = discreted0
    posqomega = posqomega0
    skpremium = wh1/wl1
    
    ! new labor CES cost
    aux1 = l3*exp(l1+l2*qgrid)/(1.+exp(l1+l2*qgrid))
    phihl = aux1/(1.-aux1)                             ! Phi_L(skill)/Phi_L(unskill)
    wq0 = (skpremium0**(1.-sigmal)*phihl + 1.)**(1./(1.-sigmal))
    wq = (wh1**(1.-sigmal)*phihl + wl1**(1.-sigmal))**(1./(1.-sigmal))
    wq = wq/wq0
    
    ! calculate new price indices and demand for foreign goods /no recalculating the equilibrium
    ! calculate new price indices and demand for foreign goods
    call gen_xquality
    call equilibriumnq(succ)  ! equilibrium where the only firm choice is exit or enter with pre-counterfactual quality
    
    call firmout1
    call firmout2
    call momentci(obj)
    
    ! shows results counterfactual
    if (toprint) then
        print *, 'obj counterINEL noq', obj, succ, '******************************'
        call show_counter
    end if
    
    end subroutine calc_objcinq