clear

capture program drop _all

program define mergesum
	local i = 2
	while `i' <= `2' {
	clear
	insheet using `1'`i'.csv
	sort firm
	capture merge 1:1 firm using firm01
	capture merge firm using firm01
	assert _merge==3
	drop _merge
	sort firm
	save firm01, replace
	local i = `i' + 1
	}
end

program define chgreal
	while "`1'" ~= "" {
	capture drop tempo
	capture gen tempo = 0.
	capture replace tempo = real(`1')
	capture replace tempo = `1'
	drop `1'
	rename tempo `1'
	mac shift
	}
	end

** read first file
insheet using `1'1.csv
sort firm
save firm01, replace

** read and merge files firms1...`2'
mergesum `1' `2'

** convert variables into real if they are read as string
chgreal firm skillm0 skillm1 skilla0 skilla1 ntsales0 ntsales1 tsales0 tsales1 discreted0 discreted1 quality0 quality1 firml0 firml1
describe
compress

** label variables
label var skillm0 "measured skill intensity, initial"
label var skillm1 "measured skill intensity, counterfactual"
label var skilla0 "actual skill intensity, initial"
label var skilla1 "actual skill intensity, counterfactual"
label var ntsales0 "normalized total sales, initial"
label var ntsales1 "normalized total sales, counterfactual"
label var quality0 "quality, initial"
label var quality1 "quality, counterfactual"
label var tsales0 "total sales, initial"
label var tsales1 "total sales, counterfactual"
rename firml0 labor0
rename firml1 labor1
label var labor0 "employment, initial"
label var labor1 "employment, counterfactual"

* discreted0 discreted1
* label var discreted "exit = 0, domestic = 1, import = 2, export = 3, imp & exp = 4"

save firm01, replace
