capture log close
log using decomposesk, replace

use `1', clear

** for inelastic labor, assert sum of labor before and after are equal
egen test = sum(labor0)
egen test1 = sum(labor1)
replace test = (test-test1)/test
sum test /*check if test is zero*/
drop test*
save tempo, replace

** generate data with skill share and labor by quartiles
** ----------------------------------------------------------
* initial
drop if skillm0 == .
sort skillm0
gen qskm = 4
replace qskm = 3 if _n< .75*_N
replace qskm = 2 if _n< .5*_N
replace qskm = 1 if _n< .25*_N
label var qskm "quartile of white-collar share"
tabulate qskm
sort qskm
by qskm: egen qlabor0 = sum(labor0)
gen aux = labor0*skillm0
by qskm: egen qskillm0 = sum(aux)
replace qskillm0 = qskillm0/qlabor0
collapse (mean) qlabor0 qskillm0, by(qskm)
egen aux = sum(qlabor0)
replace qlabor0 = qlabor0/aux
drop aux
label var qlabor0 "employment share, initial"
label var qskillm0 "white-collar share, initial"
sort qskm
save qskm, replace 

* counterfactual
use tempo, clear
drop if skillm1 == .
sort skillm1
gen qskm = 4
replace qskm = 3 if _n< .75*_N
replace qskm = 2 if _n< .5*_N
replace qskm = 1 if _n< .25*_N
label var qskm "quartile of white-collar share"
tabulate qskm
sort qskm
by qskm: egen qlabor1 = sum(labor1)
gen aux = labor1*skillm1
by qskm: egen qskillm1 = sum(aux)
replace qskillm1 = qskillm1/qlabor1
collapse (mean) qlabor1 qskillm1, by(qskm)
egen aux = sum(qlabor1)
replace qlabor1 = qlabor1/aux
drop aux
label var qlabor1 "employment share, counterfactual"
label var qskillm1 "white-collar share, counterfactual"
sort qskm
merge 1:1 qskm using qskm
drop _merge

** analyze differences
gen aux1 = qlabor1*qskillm1
gen aux0 = qlabor0*qskillm0
egen aggskm1 = sum(aux1)
egen aggskm0 = sum(aux0)


gen qlabor01 = qlabor1 - qlabor0
gen qskillm01 = qskillm1 - qskillm0

list qskm qskillm0 qlabor0 qskillm1 qlabor1 qskillm01 qlabor01

sum aggskm*

log close
exit
