 subroutine x123toall(xall, x1, x2, x3)
        use parameters_model
        implicit none
        
        real(8), dimension(n), intent(out) :: xall
        real(8), dimension(n1), intent(in) :: x1
        real(8), dimension(n2), intent(in) :: x2
        real(8), dimension(n3), intent(in) :: x3
        
        ! ------------------------------------
        !xall(1:3,5:10,15:18) 
        xall(1:3) = x1(1:3)
        xall(5:10) = x1(4:9)
        xall(14:16) = x1(10:12)
        xall(18) = x1(n1)
        xall(11:13) = x2(1:3)
        xall(17) = x2(4)
        xall(4) = x3(1)
    
 end subroutine x123toall
    
! =========================================================
 subroutine xallto123(xall, x1, x2, x3)
        use parameters_model
        implicit none
        real(8), dimension(n), intent(in) :: xall
        real(8), dimension(n1), intent(out) :: x1
        real(8), dimension(n2), intent(out) :: x2
        real(8), dimension(n3), intent(out) :: x3
        
        ! ------------------------------------
        x1(1:3) = xall(1:3)
        x1(4:9) = xall(5:10)
        x1(10:12) = xall(14:16)
        x1(n1) = xall(18)
        x2(1:3) = xall(11:13)
        x2(4) = xall(17)
        x3(n3) = xall(4)
    
    end subroutine xallto123
    
! =========================================================
subroutine  guesstoxall(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n), intent(out) :: x
    integer :: j
    ! -------------------------------------------
    
    x(1) = mu1
    x(2) = log(sigma1)
    x(3) = log(sigma2)
    x(4) = z3
    x(5) = log(f1)
    x(6) = log(f2)
    x(7) = fm
    x(8) = log(fmvar)
    x(9) = fx
    x(10) = log(fxvar)
    x(11) = l1
    x(12) = l2
    x(13) = log(skpremium)
    x(14) = log(qf)
    x(15) = log(yf)
    x(16) = log(qcf)
    x(17) = log(varpi)
    x(18) = log(nu)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1,n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine guesstoxall

! =========================================================
subroutine  xtoguessall(x) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
    z3 = x(4)
	f1 = exp(x(5))
    f2 = exp(x(6))
    fm = x(7)
    fmvar = exp(x(8))
    fx = x(9)
    fxvar = exp(x(10))
    l1 = x(11)
    l2 = x(12)
    skpremium = exp(x(13))
    qf = exp(x(14))
    yf = exp(x(15))
    qcf = exp(x(16))
    varpi = exp(x(17))
    nu = exp(x(18))
    pf = 1.d0       ! price of foreign goods. Algorithm takes it into account because it changes in counterfactual
    tariff = tariff0
    income = income0
    nfirms_data = nfirms_data0
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    !aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguessall
   
! =========================================================
subroutine  xtoguess1(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n1), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
	f1 = exp(x(4))
    f2 = exp(x(5))
    fm = x(6)
    fmvar = exp(x(7))
    fx = x(8)
    fxvar = exp(x(9))
    qf = exp(x(10))
    yf = exp(x(11))
    qcf = exp(x(12))
    nu = exp(x(13))
    pf = 1.d0       ! price of foreign goods. Algorithm takes it into account because it changes in counterfactual
    tariff = tariff0
    income = income0
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess1:'
        do j = 1, n1
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess1

! =========================================================
subroutine  xtoguess2(x) 
    use data_moments
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n2), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    l1 = x(1)
    l2 = x(2)
    skpremium = exp(x(3))
    varpi = exp(x(4))
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    !aux1 = (USAskint/(1-USAskint))*(USAskpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess2:'
        do j = 1, n2
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess2

! =========================================================
subroutine  xtoguess3(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n3), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    z3 = x(1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess3:', x
        stop
    end if
    
end subroutine xtoguess3
! =========================================================
subroutine  print_parameters
    use parameters_model
	use parameters_estimate
	implicit none
    ! -------------------------------------------
    
    print *, ' -------------------------------------------------- '
    print *, ' PARAMETERS'
    print *, 'nu     ', nu
    print *, 'mu1    ', mu1
    print *, 'sigma1 ', sigma1
    print *, 'sigma2 ', sigma2
    print *, 'z3     ', z3
    print *, 'f1     ', f1
    print *, 'f2     ', f2
    print *, 'fm     ', fm 
    print *, 'fmvar  ', fmvar
    print *, 'fx     ', fx
    print *, 'fxvar  ', fxvar
    print *, 'l1     ', l1
    print *, 'l2     ', l2
    print *, 'l3     ', l3
    print *, 'wh/wl  ', skpremium
    print *, 'qf     ', qf
    print *, 'yf     ', yf
    print *, 'Qcf    ', qcf
    print *, 'varpi	 ', varpi
    print *, ' ' 
    print *, 'alpha	 ', myalpha
    print *, ' ' 
    
end subroutine print_parameters