capture log close
log using anfirms, replace

** append data with model
** ===========================================

** model
use `1', clear
drop if discreted == 0
assert discreted <. & discreted > 0
assert hsales <. & hsales> 0
assert posqomega <. & posqomega > 0
sort posqomega
gen wrank = _n
replace wrank = wrank/wrank[_N]
sort hsales
gen hsrank = _n
replace hsrank = hsrank/hsrank[_N]
summarize wrank hsrank
keep firm wrank hsrank
global nfirms1 = _N
gen model = 1
save compare, replace

** data
use `2', clear
rename plant firm
gen hsales = tsales - esales
keep firm hsales wpw
count if hsales == 0
drop if hsales <= 0
drop if hsales == .
drop if wpw == . | wpw <=0
bys firm: assert _n == 1
sort wpw
gen wrank = _n
replace wrank = wrank/wrank[_N]
sort hsales
gen hsrank = _n
replace hsrank = hsrank/hsrank[_N]
gen model = 0
global nfirms0 = _N 		/*create macro with number of firms*/
drop hsales wpw
append using compare

** define label of model
label define spec1 0 "data" 1 "model"
label values model spec1
bys model: summarize wrank hsrank
label var wrank "wage rank"
label var hsrank "domestic sales rank"
save compare, replace

gen rd = runiform()
gen tokeep = 1 if rd < $nfirms1/$nfirms0 | model == 1
tabulate tokeep model
scatter wrank hsrank if tokeep == 1,  by(model) xlabel(0(0.25)1, grid glcolor(gs12) ) ylabel(0(0.25)1, grid glcolor(gs12)) msize(tiny)
log close
exit

pause
gen rd = runiform()
gen tokeep = 1 if rd < $nfirms1/$nfirms0 | model == 1
tabulate tokeep model
scatter wrank hsrank if model == 1, xlabel(0(0.25)1, grid glcolor(gs12) ) ylabel(0(0.25)1, grid glcolor(gs12)) msize(tiny)
pause
*scatter wrank hsrank if model == 0 & tokeep == 1, xlabel(0(0.25)1, grid glcolor(gs12) ) ylabel(0(0.25)1, grid glcolor(gs12))
*pause


* log close

