! ===============================================================
! Given the equilibrium of the economy, derives the characteristics of firms
! ===============================================================

    subroutine firmout3
    use crosssec
    use parameters_qf
    use parameters_estimate
    use random_draw
    implicit none
    
    integer(4) :: j
    
    ! input prices by quality level
    ! ===============================================
    zbarq = exp(qgrid*z3)       ! common component for productivity
        
    ! outcomes by firm
    ! ===============================================
    do j = 1, sizef
		select case(discreted(j))
        case(0)
            outprice(j) = 0.d0
        case(1)
            outprice(j) = markup*priceqh**(1.-myalpha)/zqomega(j, posqomega(j))/zbarq(posqomega(j))
        case(2)
            outprice(j) = markup*priceqa**(1.-myalpha)/zqomega(j, posqomega(j))/zbarq(posqomega(j))
        case(3)
            outprice(j) = markup*priceqh**(1.-myalpha)/zqomega(j, posqomega(j))/zbarq(posqomega(j))
        case(4)
            outprice(j) = markup*priceqa**(1.-myalpha)/zqomega(j, posqomega(j))/zbarq(posqomega(j))
        end select
    end do

    end subroutine firmout3