subroutine x123toall(xall, x1, x2, x3)
        use parameters_model
        implicit none
        
        real(8), dimension(n), intent(out) :: xall
        real(8), dimension(n1), intent(in) :: x1
        real(8), dimension(n2), intent(in) :: x2
        real(8), dimension(n3), intent(in) :: x3
        
        ! ------------------------------------
        xall(1:3) = x1(1:3)
        xall(5:11) = x1(4:10)
        xall(15:16) = x1(11:12)
        xall(12:14) = x2(1:3)
        xall(17) = x2(4)
        xall(4) = x3(1)
    
 end subroutine x123toall
    
! =========================================================
 subroutine xallto123(xall, x1, x2, x3)
        use parameters_model
        implicit none
        real(8), dimension(n), intent(in) :: xall
        real(8), dimension(n1), intent(out) :: x1
        real(8), dimension(n2), intent(out) :: x2
        real(8), dimension(n3), intent(out) :: x3
        
        ! ------------------------------------
        x1(1:3) = xall(1:3)
        x1(4:10) = xall(5:11)
        x1(11:12) = xall(15:16)
        x2(1:3) = xall(12:14)
        x2(4) = xall(17)
        x3(n3) = xall(4)
    
 end subroutine xallto123
    
! =========================================================
subroutine  guesstoxall(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n), intent(out) :: x
    integer :: j
    ! -------------------------------------------
    
    x(1) = mu1
    x(2) = log(sigma1)
    x(3) = log(sigma2)
    x(4) = z3
    x(5) = log(f1)
    x(6) = log(f2)
    x(7) = log(f3)
    x(8) = fm
    x(9) = log(fmvar)
    x(10) = fx
    x(11) = log(fxvar)
    x(12) = l1
    x(13) = l2
    x(14) = log(skpremium)
    x(15) = log(yf)
    x(16) = log(qcf)
    x(17) = log(varpi)
    
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1,n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine guesstoxall

! =========================================================
subroutine  xtoguessall(x) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
    z3 = x(4)
	f1 = exp(x(5))
    f2 = exp(x(6))
    f3 = exp(x(7))
    fm = x(8)
    fmvar = exp(x(9))
    fx = x(10)
    fxvar = exp(x(11))
    l1 = x(12)
    l2 = x(13)
    skpremium = exp(x(14))
    yf = exp(x(15))
    qcf = exp(x(16))
    varpi = exp(x(17))
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    pf = 1.d0
    tariff = tariff0
    income = income0
    nfirms_data = nfirms_data0
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguessall


! =========================================================
subroutine  xtoguess1(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n1), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    
    mu1 = x(1)
    sigma1 = exp(x(2))
    sigma2 = exp(x(3))
    f1 = exp(x(4))
    f2 = exp(x(5))
    f3 = exp(x(6))
    fm = x(7)
    fmvar = exp(x(8))
    fx = x(9)
    fxvar = exp(x(10))
    yf = exp(x(11))
    qcf = exp(x(12))
    pf = 1.d0
    tariff = tariff0
    income = income0
    nfirms_data = nfirms_data0
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox1'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess1

! =========================================================
subroutine  xtoguess2(x) 
    use parameters_model
	use parameters_estimate
    use data_moments
	implicit none

    real(8), dimension(n2), intent(in) :: x
    integer :: j
    real(8) :: aux1
    ! -------------------------------------------
    
    l1 = x(1)
    l2 = x(2)
    skpremium = exp(x(3))
    varpi = exp(x(4))
    aux1 = (USAskint/(1-USAskint))*(skpremium)**(sigmal)
    l3 = aux1/(1+aux1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, guesstox:'
        do j = 1, n
            print*, j, x(j)
        end do
        stop
    end if
    
end subroutine xtoguess2

! =========================================================
subroutine  xtoguess3(x) 
    use parameters_model
	use parameters_estimate
	implicit none

    real(8), dimension(n3), intent(in) :: x
    integer :: j
    ! -------------------------------------------
    z3 = x(1)
    
    if (any(isnan(x))) then
        print *, 'parameters not a number, xtoguess3:', x
        stop
    end if
    
end subroutine xtoguess3

! =========================================================
subroutine  print_parameters
    use parameters_model
	use parameters_estimate
	implicit none
    ! -------------------------------------------
    
    print *, ' -------------------------------------------------- '
    print *, ' PARAMETERS'
    print *, 'mu1    ', mu1
    print *, 'sigma1 ', sigma1
    print *, 'sigma2 ', sigma2
    print *, 'z3     ', z3
    print *, 'f1     ', f1
    print *, 'f2     ', f2
    print *, 'f3     ', f3
    print *, 'fm     ', fm 
    print *, 'fmvar  ', fmvar
    print *, 'fx     ', fx
    print *, 'fxvar  ', fxvar
    print *, 'l1     ', l1
    print *, 'l2     ', l2
    print *, 'l3     ', l3
    print *, 'wh/wl  ', skpremium
    print *, 'yf     ', yf
    print *, 'Qf     ', qcf
    print *, 'varpi	 ', varpi
    print *, ' ' 
    print *, 'alpha	 ', myalpha
    print *, ' ' 
    
end subroutine print_parameters