capture log close

use `1', clear

** profit non-importer decision = 0
sort quality
gen profith = priceqh^((1-$alpha)*(1-$sigma))*chiq
gen profita = priceqa^((1-$alpha)*(1-$sigma))*chiq
gen profita2 = priceqa^((1-$alpha)*(1-$sigma))*(chiq + chiqf)

gen dph = (profith - profith[_n-1])/(quality - quality[_n-1])
gen dpa = (profita - profita[_n-1])/(quality - quality[_n-1])
gen dpa2 = (profita2 - profita2[_n-1])/(quality - quality[_n-1])
*gen f2 = .005
 gen f2 = 1.46e-4
 
sort quality
line profith profita profita2 quality, lpattern(solid dash longdash_dot) legend(order(1 "domestically-oriented firm" 2 "importing only" 3 "importing and exporting") cols(1))
pause
line dph dpa dpa2 f2 quality if quality <5, lpattern(solid dash longdash_dot ) legend(order(1 "domestically-oriented firm" 2 "importing only" 3 "importing and exporting" ) cols(1))
pause

** shifts in profits due to productivity
global se1 = 0.6
global se2 = 0.01
gen z2 = 1+$se2*quality

gen profith2 = (1.+$se1)*priceqh^((1-$alpha)*(1-$sigma))*chiq
gen profith3 = z2^($sigma-1)*priceqh^((1-$alpha)*(1-$sigma))*chiq
gen dph2 = (profith2 - profith2[_n-1])/(quality - quality[_n-1])
gen dph3 = (profith3 - profith3[_n-1])/(quality - quality[_n-1])

line profith profith2 profith3 quality, lpattern(solid dash longdash_dot) legend(order(1 "benchmark firm" 2 "standard deviation in z1" 3 "standard deviation in z2") cols(1))
pause
line dph dph2 dph3 f2 quality if quality <4, lpattern(solid dash longdash_dot ) legend(order(1 "benchmark firm" 2 "standard deviation in z1" 3 "standard deviation in z2")  cols(1))
pause

exit
