
use `1', clear

* adjust quality to add up to 1
capture drop tempo
egen tempo = sum(nq0)
replace nq0 = nq0/tempo
drop tempo
egen tempo = sum(nq0)
assert tempo> 0.999999 & tempo < 1.00001
drop tempo
egen tempo = sum(nq1)
replace nq1 = nq1/tempo
drop tempo
egen tempo = sum(nq1)
assert tempo> 0.999999 & tempo < 1.00001
drop tempo

* scatter nq0 nq1 quality, msize(small) msymbol(O t) || line skillq quality, yaxis(2)
* pause

scatter nq0 nq1 quality, msize(small) msymbol(O th) 
* pause

* cummulative mass of firms
sort quality
gen cnq0 = sum(nq0)
replace cnq0 = cnq0/cnq0[_N]
gen cnq1 = sum(nq1)
replace cnq1 = cnq1/cnq1[_N]
list quality cnq0 cnq1

* statistics for the 10th and 90th percentiles of initial quality distribution
gen tempo = 1 if cnq0[_n]>=.1 & cnq0[_n-1]<.1
replace tempo = 2 if cnq0[_n]>=.9 & cnq0[_n-1]<.9
replace tempo = 3 if cnq1[_n]>=.9 & cnq1[_n-1]<.9
gen dpa = priceqa1/priceqa0
gen dph = priceqh1/priceqh0
sort tempo 
gen ddpa = dpa[_n]/dpa[1]
gen ddph = dph[_n]/dph[1]
** change in price of importers
list quality priceqa0 priceqa1 dpa ddpa if tempo <.

** change in price of non-importers
list quality priceqh0 priceqh1 dph ddph if tempo <.
pause

sort quality
drop tempo dpa dph ddpa ddph
gen tempo = 1 if quality[_n]>=2.99 & quality[_n-1]<2.99
replace tempo = 2 if quality[_n]>=5.99 & quality[_n-1]<5.99
replace tempo = 3 if quality[_n]>=6.99 & quality[_n-1]<6.99
gen dpa = priceqa1/priceqa0
gen dph = priceqh1/priceqh0
sort tempo 
gen ddpa = dpa[_n]/dpa[1]
gen ddph = dph[_n]/dph[1]

** change in price of importers
list quality priceqa0 priceqa1 cnq0 cnq1 ddpa if tempo <.

** change in price of non-importers
list quality priceqh0 priceqh1 cnq0 cnq1 ddph if tempo <.
pause

** q-measure for 90th percentile in periods 0 and 1
list quality chiq0 if tempo == 2 | tempo == 3
sort tempo
display chiq0[2], chiq0[3], chiq0[3]/chiq0[2]-1
sort quality
replace tempo = 4 if cnq0[_n]>=.75 & cnq0[_n-1]<.75
replace tempo = 5 if cnq1[_n]>=.75 & cnq1[_n-1]<.75
list quality chiq0 if tempo == 4 | tempo == 5
sort tempo
display chiq0[4], chiq0[5], chiq0[5]/chiq0[4]-1
pause

exit
