clear

capture program drop _all

program define mergesum
	local i = 2
	while `i' <= `2' {
	clear
	insheet using `1'`i'.csv
	sort quality
	capture merge 1:1 quality using quality01
	capture merge quality using quality01
	assert _merge==3
	drop _merge
	sort quality
	save quality01, replace
	local i = `i' + 1
	}
end

program define chgreal
	while "`1'" ~= "" {
	capture drop tempo
	capture gen tempo = 0.
	capture replace tempo = real(`1')
	capture replace tempo = `1'
	drop `1'
	rename tempo `1'
	mac shift
	}
	end

** read first file
insheet using `1'1.csv
sort quality
save quality01, replace

** read and merge files firms1...`2'
mergesum `1' `2'

** convert variables into real if they are read as string
chgreal quality priceqa0 priceqa1 priceqh0 priceqh1 nq0 nq1
compress
describe

** label variables
label var nq0 "initial quality"
label var nq1 "counterfactual quality"
label var priceqa0 "input price for importers, initial"
label var priceqa1 "input price for importers, counterfactual" 
label var priceqh0 "input price for non-importers, initial"
label var priceqh1 "input price for non-importers, counterfactual"
save quality01, replace
