pause on
global alpha = 0.3
global sigma = 5.
global markup = $sigma/($sigma-1)
global nfirms = 6710	 	/* number of firms to plot size x wages in joint_sw*/
**pause off

** general market analysis
do crsummary quality 6
do ansummary summary		/* plots quality choices and skill intensities */
	
do anprofits summary
	
	
** moments
do crfirms firm 4
do anfirms firms rt_manu_88	/* plots rank of wages and sales */
pause

** counterfactual
do crquality01 counterq 5
do anquality01 quality01
exit
do crfirm01 counterf 7
do decomposesk firm01  /* does the decomposition of changes in skills and employment in appendix */
do anfirms01 firm01

** to compare counterfactuals
** run Fortran with first counterfactual
do crfirm01 counterf 6
do anfirms01 firm01
sort firm
save temp1, replace
** run Fortran with second counterfactual
do crfirm01 counterf 6
do anfirms01 firm01
do compare

** compare different skill specifications
* =============================================================
data file saved as nqskill, nqskill2 for aug 2016 results, nqskillA for sept 2016 results

scatter nq0 nq1 quality, msize(small) msymbol(O th) || line skillq quality, yaxis(2)
* edited graph
line skill_bounded skill_linear skill_unbounded  quality, lpattern(solid dash dash_dot) || scatter nq0 nq1 quality, msize(small) msymbol(O th) yaxis(2) legend(order( - "skill intensity (left axis):" - " " 1 2 3 - " " - "distribution of qualities (right axis)" - 4 5))

exit
