    ! ---------------------------------------------------------------------
    ! returns a vector with results from phi function
    ! ---------------------------------------------------------------------
    subroutine phiv(sizev, qvdiff, mynu, phivo)
    implicit none
    
    integer(4), intent(in) :: sizev
    real(8), dimension(sizev), intent(in) :: qvdiff         ! vector with q'-q (input quality - output or reference quality)
    real(8), intent(in) :: mynu
    real(8), dimension(sizev), intent(out) :: phivo         ! output vector with phi function
    
    ! ---------------------------------------------------------------------
    phivo = exp(mynu*qvdiff)/( 1. + exp(mynu*qvdiff) )
    
    end subroutine phiv
    
    ! ---------------------------------------------------------------------
    ! returns a scalar with results from phi function
    ! ---------------------------------------------------------------------
    subroutine phir(qdiff, mynu, phiro)
    implicit none
    
    real(8), intent(in) :: qdiff         ! vector with q'-q (input quality - output or reference quality)
    real(8), intent(in) :: mynu
    real(8), intent(out) :: phiro         ! output vector with phi function
    
    ! ---------------------------------------------------------------------
    phiro = exp(mynu*qdiff)/( 1. + exp(mynu*qdiff) )
    
    end subroutine phir